<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:al_p="http://www.eo.ee/xml/xsl/perlscripts">


	<xsl:output method="xml" omit-xml-declaration="no" indent="no" encoding="utf-8" />

	<xsl:variable name="qryMode"/>
	<xsl:variable name="art_xpath">*</xsl:variable>

	
	<xsl:template match="/">
		<xsl:copy>
			<xsl:apply-templates select="al:sr" />
		</xsl:copy>
	</xsl:template>


	<xsl:template match="al:sr">
		<xsl:copy>
			<xsl:copy-of select="@*" />
			<xsl:choose>
				<xsl:when test="$qryMode = 'useM'">
					<xsl:variable name="artNrs">
						<xsl:for-each select="$art_xpath">
              <xsl:if test="position() > 1">
                <xsl:choose>
                  <xsl:when test="position() = last()">:</xsl:when>
                  <xsl:otherwise>;</xsl:otherwise>
                </xsl:choose>
              </xsl:if>
              <xsl:number format="1" level="single" from="al:sr"/>
            </xsl:for-each>
					</xsl:variable>
          <xsl:variable name="algus">
            <xsl:choose>
              <xsl:when test="contains(substring-before($artNrs, ':'), ';')">
                <xsl:value-of select="substring-before($artNrs, ';')"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="substring-before($artNrs, ':')"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:variable>
          <xsl:variable name="lopp">
            <xsl:value-of select="substring-after($artNrs, ':')"/>
          </xsl:variable>
					<xsl:apply-templates select="al:A[position() &gt;= number($algus) and position() &lt;= number($lopp)]" mode="printout"></xsl:apply-templates>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates select="$art_xpath" mode="printout"></xsl:apply-templates>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>


	<xsl:template match="al:A" mode="printout">
		<xsl:copy-of select="current()" />
	</xsl:template>


</xsl:stylesheet>
