#!/usr/bin/perl

# $ENV{PERL_BADFREE} = 0;

use strict;

# Only one case remains where an explicit use utf8 is needed:
# if your Perl script itself is encoded in UTF-8,
# you can use UTF-8 in your identifier names,
# and in string and regular expression literals, by saying use utf8.

use utf8;


# decode_utf8, encode_utf8 ...
use Encode;


# To output UTF-8, use the :utf8 output layer. Prepending
# binmode(STDOUT, ":utf8");
# to this program ensures that the output is completely UTF-8.

# binmode(STDOUT, ":utf8");



use XML::LibXML;
my $dicparser = XML::LibXML->new();
$dicparser->validation(0);
$dicparser->recover(0);
$dicparser->expand_entities(1);
$dicparser->keep_blanks(0);
$dicparser->pedantic_parser(0);
$dicparser->line_numbers(0);
$dicparser->load_ext_dtd(0);
$dicparser->complete_attributes(0);
$dicparser->expand_xinclude(0);
$dicparser->clean_namespaces(1);


# *****************************************************
# Constants
# *****************************************************

my $lcDom = $dicparser->parse_file('lc.xml');

use CGI;
my $q = new CGI;

# my $pd = decode_utf8($q->param('POSTDATA'));
my $pd = $q->param('POSTDATA');

if ($pd eq '') {
	print "Content-type: text/html; charset=utf-8\n\n"; #header utf-8 -s
	print 'not defined.';
	exit;
}

my $prmDOM = $dicparser->parse_string($pd);

my $APP_LANG = $prmDOM->documentElement()->findvalue('app_lang');
my $DIC_DESC = $prmDOM->documentElement()->findvalue('dic_desc');

my $cmdId = $prmDOM->documentElement()->findvalue('cmd');
my $dicVol = $prmDOM->documentElement()->findvalue('vol'); # "ief1" jne
my $qinfo = $prmDOM->documentElement()->findvalue('nfo');
my $art_xpath = $prmDOM->documentElement()->findvalue('axp');
my $elm_xpath = $prmDOM->documentElement()->findvalue('exp');
my $artG = $prmDOM->documentElement()->findvalue('G');

my $what = $prmDOM->documentElement()->findvalue('w');

my $withCase = $prmDOM->documentElement()->findvalue('wC');
my $withSymbols = $prmDOM->documentElement()->findvalue('wS');
my $evPath = $prmDOM->documentElement()->findvalue('evP');
my $getFrXmlPath = $prmDOM->documentElement()->findvalue('getFrXmlPath');
unless ($getFrXmlPath) {
	$getFrXmlPath = $evPath;
}
my $msAttCond = $prmDOM->documentElement()->findvalue('msAC');
my $seldQn = $prmDOM->documentElement()->findvalue('qn');
my $seldLn = substr($seldQn, index($seldQn, ':') + 1);
my $msO = $prmDOM->documentElement()->findvalue('msO');
my $sql = $prmDOM->documentElement()->findvalue('sql');

my $fSrchPtrn = $prmDOM->documentElement()->findvalue('fSrP');
# ei saa kõiki sümboleid maha võtta, sest peab saama otsida ka fakultatiivseid osasi märksõnast (tsipake[ne])
my $fSubstPtrn = '&(((em|b|sub|sup|l)(a|l)));'; #ainult kirjastiilid
if (substr($fSrchPtrn, 0, 4) eq '(?õ)') {
	$fSrchPtrn = substr($fSrchPtrn, 4);
	$withSymbols = '0';
}

#'noLetters' sobib sel kujul 'textContent' jaoks: '&amp;' asemel on '&'
# my $noLetters = qr/&((em|b|sub|sup|l)(a|l));|[^\p{L}\s]/;
my $noLetters = qr/(&\w+;)|[^\p{L}\s]/;
my $hlPtrn = $prmDOM->documentElement()->findvalue('hlP');

my $fakPtrn = $prmDOM->documentElement()->findvalue('ffkP');

if ($withCase eq '0') { # tõstutundetu
	unless ($fSrchPtrn eq '') {
		$fSrchPtrn = '(?i)' . $fSrchPtrn;
		$hlPtrn = '(?i)' . $hlPtrn;
	}
}
my $isPtrn = 0;
unless ($fSrchPtrn eq '') {
	$fSubstPtrn = qr/$fSubstPtrn/;
	$fSrchPtrn = qr/$fSrchPtrn/;
	$hlPtrn = qr/$hlPtrn/;
	$isPtrn = 1;
}
my $fMySQLPtrn = $prmDOM->documentElement()->findvalue('fMsqlP');
my $mySqlLikePtrn = $prmDOM->documentElement()->findvalue('fMsqlLike');
my $destVol = $prmDOM->documentElement()->findvalue('dV');

my $qryMethod = $prmDOM->documentElement()->findvalue('qM');
my $artMuudatused = $prmDOM->documentElement()->findvalue('artCh');

my $shsconfig = $dicparser->parse_file("shsconfig_${DIC_DESC}.xml");
my $appDesc = $shsconfig->documentElement()->findvalue('appDesc');
my $MAX_LEIUD = $shsconfig->documentElement()->findvalue('max_leiud');
my $MAX_PRINT_ARTS = $shsconfig->documentElement()->findvalue('max_print_arts');
my $DIC_VOLS_COUNT = $shsconfig->documentElement()->findnodes('vols/vol')->size();
my $DICPR = $shsconfig->documentElement()->findvalue('dicpr');
my $DICURI = $shsconfig->documentElement()->findvalue('dicuri');

my $FIRST_DEFAULT = $shsconfig->documentElement()->findvalue('first_default');
my $fdArt = substr($FIRST_DEFAULT, index($FIRST_DEFAULT, '/') + 1);
my $default_query = $shsconfig->documentElement()->findvalue('default_query');
my $qn_ms = substr($default_query, rindex($default_query, '/') + 1);

my $fakOlemas = $shsconfig->documentElement()->findvalue('fakult');
my $fakOsataPtrn;
if ($fakOlemas) {
	$fakOsataPtrn = '\\' . substr($fakOlemas, 0, 1) . '.*?\\' . substr($fakOlemas, 1, 1);
	$fakOsataPtrn = qr/$fakOsataPtrn/;
}

my ($usrName, $nEditAllowed);
$nEditAllowed = 0;
if ($appDesc eq 'EXSA') {
	$usrName = $prmDOM->documentElement()->findvalue('un');
	$nEditAllowed = 1;
}
else {
	$usrName = "$ENV{REMOTE_USER}";
	unless ($usrName eq "vaataja" || $usrName eq "h6beValge" || $usrName eq "xmlStats") {
		$nEditAllowed = 1;
	}
}
if ($usrName eq "") {
	print "Content-type: text/html; charset=utf-8\n\n"; #header utf-8 -s
	print 'not defined.';
	exit;
}

my $usrUnName = "";
my $uJnr;
for ($uJnr = 0; $uJnr < length($usrName); $uJnr++) {
	if ($uJnr > 0) {
		$usrUnName .= "_"
	}
	$usrUnName .= ord(substr($usrName, $uJnr, 1));
}

# Viimane parameeter - 0 - määrab, et ainult NS deklaratsioon kirjutatakse.
# Kui 'setNamespace' mitte panna, tuleb viga prmDOM otsingul: undefined prefix jne.
$prmDOM->documentElement()->setNamespace($DICURI, $DICPR, 0);

my $remoteAddress = $ENV{REMOTE_ADDR};


my $queryFileID = "${usrUnName}_${DIC_DESC}";


# *****************************************************
# Functions
# *****************************************************


# tavalise XML päringu juures
sub srch {
	my $nodeList = shift(@_);

	# findvalue is exactly equivalent to:
	#	$node->find( $xpath )->to_literal;

	#textContent (Node): this function returns the content of all text nodes in the descendants of the given node as specified in DOM.
	#to_literal (NodeList): Returns the concatenation of all the string-values of all the nodes in the list. This could be used as the equivalent of XSLT's <xsl:value-of select="some_xpath"/>.
	#string_value (NodeList): Returns the string-value of the first node in the list. See the XPath specification for what "string-value" means.
	#toString (Node): It returns a string consisting of XML serialization of the given node and all its descendants ("outerXml", "xml")

	my ($i, $nodeText);
	for ($i = 1; $i <= $nodeList->size(); $i++) {
	
		# kas element (self::node() korral) või tekst (text())
		# textContent: '&amp;' -> '&'
		$nodeText = $nodeList->get_node($i)->textContent;
		
		if ($withSymbols eq '0') {
			$nodeText = t6lgi($nodeText);
			if ($fakPtrn) {
				my $fakOsata = $nodeText;
				$fakOsata =~ s/$fakOsataPtrn//g; #sulud ja tema sees olev maha
				$fakOsata =~ s/$noLetters//g;
				if ($fakOsata =~ /$fSrchPtrn/o) {
					return 1;
				}
			}
			$nodeText =~ s/$noLetters//g;
		}
		if ($nodeText =~ /$fSrchPtrn/) {
			return 1;
		}
	}
	return 0;
}

# tavalise XML päringu juures
sub showHL {

	# siia tuleb sisse tekst nood (text()) ...
	
	# textContent: '&amp;' -> '&'
	# textContent: krahvitar, &ema;&la;count&ll;&eml;’i abikaasa v tütar
	# toString: krahvitar, &amp;ema;&amp;la;count&amp;ll;&amp;eml;’i abikaasa v tütar
	# peab jätma "toString", sest on ainuke, mis ei moonuta
	my $tekst = shift(@_)->get_node(1)->textContent;
	if ($isPtrn) {
		if ($withSymbols eq '0') {
			# ainult kirjastiilid maha
			$tekst =~ s/$fSubstPtrn//g;
		}
		$tekst =~ s/($fSrchPtrn)/<span class='_hl'>$1<\/span>/g;
	}
	return $tekst;
}

# eraldi otsingufunktsioon, nt atribuudi teksti juures XML tavapäringus
sub srch2 {
	my $attText = shift(@_)->to_literal();
	my $attPtrn = decode_utf8(shift(@_));
	my $attSubst = shift(@_);

	if ($attSubst) {
		$attText =~ s/$attSubst//og;
	}
	if ($attText =~ /$attPtrn/o) {
		return 1;
	}

	return 0;

}


my ($viimane_vol_nr, $viimaneArt, $artsCount);

sub teeXMLStr {

	my ($leiuTekst, $leiuTekstOrg, $md, $TA, $viimaneG, $g, $artLeiuNr);
	my $className = '_bhl';
	my $artsXML = '';

	$artsCount = 0;
	$viimaneG = '';

	my $stHandle = shift(@_);
	my $lisand = decode_utf8(shift(@_));
	while (my $ref = $stHandle->fetchrow_hashref()) {

		$leiuTekst = decode_utf8($ref->{'l'});
		$leiuTekstOrg = $leiuTekst;

#		unless ($leiuTekstOrg =~ /&/) {
#			if ($isPtrn) {
#				$leiuTekstOrg =~ s/($hlPtrn)/<span class='${className}'>$1<\/span>/g;
#			}
#		}

		$g = $ref->{'G'};
		if ($g ne $viimaneG) {

			$artsCount++;

			if ($artsCount <= $MAX_PRINT_ARTS) {
				if ($viimaneG) {
					$artsXML .= '</t></l></A>';
				}

				$artsXML .= '<A>';

				$viimaneArt = decode_utf8($ref->{'art'});
				$viimane_vol_nr = $ref->{'vol_nr'};

				$artsXML .= "<vf>${DIC_DESC}${viimane_vol_nr}</vf>";
				$md = decode_utf8($ref->{'md'});
				$artsXML .= "<md>";
					$artsXML .= "<t>${md}</t>";
				$artsXML .= "</md>";
				$artsXML .= '<tlkn></tlkn>';
				$artsXML .= '<maht></maht>';
				$artsXML .= '<K>' . decode_utf8($ref->{'K'}) . '</K>';
				$artsXML .= '<T>' . decode_utf8($ref->{'T'} . '</T>');
				$TA = $ref->{'TA'};
				if ($TA eq '0000-00-00 00:00:00') { #vähem liiklust
					$TA = '';
				}
				$artsXML .= "<TA>${TA}</TA>";
				$artsXML .= '<PT>' . decode_utf8($ref->{'PT'}) . '</PT>';
				$artsXML .= "<G>${g}</G>";

				$artsXML .= "<l><t>";
				$artLeiuNr = 0;
			}
		}

		if ($artsCount <= $MAX_PRINT_ARTS) {
			if ($artLeiuNr > 0) {
				$artsXML .= ' :: ';
			}
			$artLeiuNr++;
			$artsXML .= "<span class='_b' nr='${artLeiuNr}'>";
				$artsXML .= "${lisand}‹${seldLn}";
				if ($ref->{'ms_att_i'}) {
					$artsXML .= ' ▫i="' . $ref->{'ms_att_i'} . '"';
				}
				if ($ref->{'ms_att_liik'}) {
					$artsXML .= ' ▫liik="' . $ref->{'ms_att_liik'} . '"';
				}
				if ($ref->{'ms_att_ps'}) {
					$artsXML .= ' ▫ps="' . decode_utf8($ref->{'ms_att_ps'}) . '"';
				}
				if ($ref->{'ms_att_tyyp'}) {
					$artsXML .= ' ▫tyyp="' . $ref->{'ms_att_tyyp'} . '"';
				}
				if ($ref->{'ms_att_mliik'}) {
					$artsXML .= ' ▫mliik="' . $ref->{'ms_att_mliik'} . '"';
				}
				if ($ref->{'ms_att_k'}) {
					$artsXML .= ' ▫k="' . $ref->{'ms_att_k'} . '"';
				}
				if ($ref->{'ms_att_mm'}) {
					$artsXML .= ' ▫mm="' . $ref->{'ms_att_mm'} . '"';
				}
				if ($ref->{'ms_att_st'}) {
					$artsXML .= ' ▫st="' . $ref->{'ms_att_st'} . '"';
				}
				if ($ref->{'ms_att_vm'}) {
					$artsXML .= ' ▫vm="' . $ref->{'ms_att_vm'} . '"';
				}
				if ($ref->{'ms_att_all'}) {
					$artsXML .= ' ▫all="' . $ref->{'ms_att_all'} . '"';
				}
				if ($ref->{'ms_att_uus'}) {
					$artsXML .= ' ▫uus="' . $ref->{'ms_att_uus'} . '"';
				}
				if ($ref->{'ms_att_zs'}) {
					$artsXML .= ' ▫zs="' . $ref->{'ms_att_zs'} . '"';
				}
				if ($ref->{'ms_att_u'}) {
					$artsXML .= ' ▫u="' . $ref->{'ms_att_u'} . '"';
				}
				if ($ref->{'ms_att_em'}) {
					$artsXML .= ' ▫em="' . $ref->{'ms_att_em'} . '"';
				}
				$artsXML .= "›";
			$artsXML .= "</span>";
			$artsXML .= " ▪${leiuTekstOrg}";
		}
		
		$viimaneG = $g;
		
	} # while ($ref = $stHandle->fetchrow_hashref()) {
	
	if ($viimaneG) {
		$artsXML .= '</t></l></A>';
	}

	return $artsXML;
}


# NB! : ka tools.cgi
sub t6lgi {
	my $sisend = shift(@_);
	$sisend =~ tr/ÀÁÅÅàáÈÉèé/AAAAaaEEee/d;
	return $sisend;
}

# NB! : ka tools.cgi
sub teeMs_nosKuju {
	my $ms_nos = shift(@_);
	$ms_nos =~ s/&amp;/&/og; #kuna 'mTekstid' on 'toString', siis on '&amp;ema;' jne
	$ms_nos =~ s/$noLetters//g;
	$ms_nos = t6lgi($ms_nos);
	return $ms_nos;
}


use XML::LibXSLT;
my $xslt = XML::LibXSLT->new();
my $XSLSCRIPTSURI = 'http://www.eo.ee/xml/xsl/perlscripts';
XML::LibXSLT->register_function($XSLSCRIPTSURI, 'rex', \&rex);
XML::LibXSLT->register_function($XSLSCRIPTSURI, 'srch', \&srch);
XML::LibXSLT->register_function($XSLSCRIPTSURI, 'srch2', \&srch2);
XML::LibXSLT->register_function($XSLSCRIPTSURI, 'showHL', \&showHL);

my $queryXSL = $dicparser->parse_file('xsl/query.xsl');
$queryXSL->documentElement()->setNamespace($DICURI, 'al', 0);
$queryXSL->documentElement()->setNamespace($DICURI, $DICPR, 0);

my $xslnode;
# $xslnode = $queryXSL->documentElement()->findnodes("xsl:variable[\@name='dic_desc']")->get_node(1);
# $xslnode->firstChild->setData($DIC_DESC);
$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/xsl:variable[\@name = 'marksonad']/xsl:choose/xsl:otherwise/xsl:for-each[\@select = 'siinTulebAsendada']")->get_node(1);
$xslnode->setAttribute("select", substr($default_query, index($default_query, '/') + 1));
$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/md/e/xsl:choose/xsl:otherwise")->get_node(1);
$xslnode->setAttribute("select", $qn_ms);
$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/O/xsl:value-of[\@select = 'siinTulebVeelAsendada']")->get_node(1);
$xslnode->setAttribute("select", "${fdArt}/\@${DICPR}:O");

my $sortXSL = $dicparser->parse_file('xsl/mssvorder.xsl');
$sortXSL->documentElement()->setNamespace($DICURI, 'al', 0);
$sortXSL->documentElement()->setNamespace($DICURI, $DICPR, 0);
$xslnode = $sortXSL->documentElement()->findnodes("xsl:variable[\@name='dic_desc']")->get_node(1);
$xslnode->firstChild->setData($DIC_DESC);
$xslnode = $sortXSL->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/xsl:copy/xsl:choose/xsl:otherwise/xsl:apply-templates/xsl:sort[\@select = 'siinTulebAsendada']")->get_node(1);
$xslnode->setAttribute("select", "translate(" . substr($default_query, index($default_query, '/') + 1) . "/\@${DICPR}:O, \$etfr, \$to_sym)");


my $responseXML = <<"responseXML";
<?xml version="1.0" encoding="utf-8" standalone="no"?>
<rsp xmlns:${DICPR}="${DICURI}">
	<sta />
	<cnt />
	<vol />
	<qM />
</rsp>
responseXML
my $responseDOM = $dicparser->parse_string($responseXML);
my $rsp_status_node = $responseDOM->documentElement()->findnodes('sta')->get_node(1);
my $rsp_count_node = $responseDOM->documentElement()->findnodes('cnt')->get_node(1);
my $rsp_vol_node = $responseDOM->documentElement()->findnodes('vol')->get_node(1);
my $rsp_qM_node = $responseDOM->documentElement()->findnodes('qM')->get_node(1);

if (length($fMySQLPtrn) > 2048) {
	$cmdId = "x";
	$rsp_status_node->appendTextNode('length($fMySQLPtrn) = ' . length($fMySQLPtrn));
}

my $admMsg = $shsconfig->documentElement()->findvalue('msg');
if ($admMsg) {
	$cmdId = "y";
	$rsp_status_node->appendTextNode($admMsg);
}


my $outXML = <<"outXML";
<?xml version="1.0" encoding="utf-8" standalone="no"?>
<outDOM />
outXML
my $outDOM = $dicparser->parse_string($outXML);

# po siin, so globaalsed teiste suhtes ...
my ($dicDOM, $qryDOM, $printDOM);
my ($i, $j, $k);
my $opMs;
my $opAttrs;


my $nStatus = 0;

use Fcntl ':flock';
my $lockType;
if ($^O eq 'MSWin32') {
	$lockType = LOCK_SH;
}
else {
	$lockType = (LOCK_EX | LOCK_NB);
}

my $eeLexConfDom = $dicparser->parse_file('shsConfig.xml');
my $eeLexQM = $eeLexConfDom->documentElement()->findvalue('qmMySql');
if (index($eeLexQM, ";${DIC_DESC};") < 0) {
	$qryMethod = 'XML';
}

my $mySqlDbName = 'xml_dicts';
if (index($ENV{SCRIPT_NAME}, '/__shs_test/') > -1) {
	$mySqlDbName = 'xml_dicts_test';
}

$rsp_qM_node->appendTextNode($qryMethod);

my $browseInfoStr = "<r>
	<i n='q'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'QUERY'][\@l = '${APP_LANG}']") . "</i>
	<i n='l'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'MATCHES'][\@l = '${APP_LANG}']") . "</i>
	<i n='e'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'ENTRIES'][\@l = '${APP_LANG}']") . "</i>
	<i n='nr'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'NR'][\@l = '${APP_LANG}']") . "</i>
	<i n='v'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'VOLUME'][\@l = '${APP_LANG}']") . "</i>
	<i n='hw'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'HEADWORDS'][\@l = '${APP_LANG}']") . "</i>
	<i n='m'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'MATCH'][\@l = '${APP_LANG}']") . "</i>
	<i n='tr'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'TRANSLATOR'][\@l = '${APP_LANG}']") . "</i>
	<i n='capy'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'CAPACITY'][\@l = '${APP_LANG}']") . "</i>
	<i n='K'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'CREATOR'][\@l = '${APP_LANG}']") . "</i>
	<i n='T'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'EDITOR'][\@l = '${APP_LANG}']") . "</i>
	<i n='TA'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'EDITED'][\@l = '${APP_LANG}']") . "</i>
	<i n='PT'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'SIGNER'][\@l = '${APP_LANG}']") . "</i>
	<i n='flt'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'FLT'][\@l = '${APP_LANG}']") . "</i>
	<i n='ts'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'SORT'][\@l = '${APP_LANG}']") . "</i>
	<i n='mpa'>" . $lcDom->documentElement()->findvalue("itm[\@n = 'FIRSTTOSHOW'][\@l = '${APP_LANG}']") . " ${MAX_PRINT_ARTS} " . $lcDom->documentElement()->findvalue("itm[\@n = 'ENTRIES'][\@l = '${APP_LANG}']") . "</i>";
if ($qryMethod eq 'MySql') {
	$browseInfoStr .= "<qM>MySQL.ico</qM>";
}
else {
	$browseInfoStr .= "<qM>xml_16-16.ico</qM>";
}
$browseInfoStr .= "<dd>${DIC_DESC}</dd>
			</r>";

my $sqlCmd;

my $startTime = time();
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($startTime);
my $nowdtstr = sprintf("%04d-%02d-%02dT%02d:%02d:%02d", $year + 1900, $mon + 1, $mday, $hour, $min, $sec);
my $logFileName = substr($nowdtstr, 0, 10);

use DBI();


if ($cmdId eq "BrowseRead") {

	if ($qryMethod eq 'MySql') {

		my $dbh = DBI->connect("DBI:mysql:database=${mySqlDbName};mysql_enable_utf8=1;host=192.168.11.11",
							 "eelex", "EELex",
							 {'RaiseError' => 1});
		
		my $vNr = substr($dicVol, 3, 1);
		$sqlCmd = "SELECT ${DIC_DESC}.art AS art FROM ${DIC_DESC} WHERE ${DIC_DESC}.G = '${artG}' AND ${DIC_DESC}.vol_nr = ${vNr}";
		my $sth = $dbh->prepare($sqlCmd);
		$sth->execute();
		my $artCnt = $sth->rows;
		if ($artCnt == 1) {
			if (my $ref = $sth->fetchrow_hashref()) {
				my $artDom = $dicparser->parse_string(decode_utf8($ref->{'art'}));
				$rsp_status_node->appendTextNode("Success");
				$rsp_count_node->appendTextNode($artCnt);
				$rsp_vol_node->appendTextNode($dicVol);
				$responseDOM->documentElement()->appendChild($responseDOM->importNode($artDom->documentElement()));
			}
		}
		else {
			$rsp_status_node->appendTextNode("Failed on select: '${sqlCmd}' (${artCnt} tk) (${cmdId})!");
		}
		
		$sth->finish();
		# Disconnect from the database.
		$dbh->disconnect();
	}
	else {
		my $xmlFile = "__sr/${DIC_DESC}/${dicVol}.xml";
		my $nodes;

		if (open(XMLF, '<:utf8', $xmlFile)) {
	#		if (flock(XMLF, $lockType)) {
				$dicDOM = $dicparser->parse_file($xmlFile);
				my $xPath = "${DICPR}:A[${DICPR}:G = '${artG}']";
				$nodes = $dicDOM->documentElement()->findnodes($xPath);

				$rsp_count_node->appendTextNode($nodes->size());
				
				my $artCnt = $nodes->size();
				if ($artCnt == 1) {
					$rsp_status_node->appendTextNode("Success");
					$rsp_vol_node->appendTextNode($dicVol);
					$responseDOM->documentElement()->appendChild($responseDOM->importNode($nodes->get_node(1)));
				}
				else {
					$rsp_status_node->appendTextNode("Failed on 'findnodes(${xPath}) (${artCnt} tk) (${cmdId})!");
				}
	#			flock(XMLF, LOCK_UN);
	#		}
	#		else {
	#			$rsp_status_node->appendTextNode("Failed to flock '${xmlFile}' (${cmdId})!");
	#		}
			close(XMLF);
		}
		else {
			$rsp_status_node->appendTextNode("Failed to open '${xmlFile}' (${cmdId})!");
		}
	}
}
elsif ($cmdId eq "prevNextRead") {

	my $vNr = substr($dicVol, 3, 1);

	if ($qryMethod eq 'MySql') {
		my $dbh = DBI->connect("DBI:mysql:database=${mySqlDbName};mysql_enable_utf8=1;host=192.168.11.11",
							 "eelex", "EELex",
							 {'RaiseError' => 1});
		my $sisemine = "SELECT ${DIC_DESC}.ms_att_OO AS OO FROM ${DIC_DESC} WHERE ${DIC_DESC}.G = '${artG}'";
		my ($ting, $leitud, $art, $sth);
		if ($elm_xpath eq '-1') { # eelmine
			$ting = "WHERE ms_att_OO <= (${sisemine}) AND vol_nr = ${vNr} ORDER BY ms_att_OO DESC LIMIT 20";
			$sqlCmd = "SELECT ${DIC_DESC}.art AS art, ${DIC_DESC}.G AS G FROM ${DIC_DESC} $ting";
			$sth = $dbh->prepare($sqlCmd);
			$sth->execute();
			while (my $ref = $sth->fetchrow_hashref()) {
				if ($leitud) {
					$art = $ref->{'art'};
					last;
				}
				else {
					if ($ref->{'G'} eq $artG) {
						$leitud = 1;
					}
				}
			}
		}
		elsif ($elm_xpath eq '1') { # järgmine
			$ting = "WHERE ms_att_OO >= (${sisemine}) AND vol_nr = ${vNr} ORDER BY ms_att_OO ASC LIMIT 20";
			$sqlCmd = "SELECT ${DIC_DESC}.art AS art, ${DIC_DESC}.G AS G FROM ${DIC_DESC} $ting";
			$sth = $dbh->prepare($sqlCmd);
			$sth->execute();
			while (my $ref = $sth->fetchrow_hashref()) {
				if ($leitud) {
					$art = $ref->{'art'};
					last;
				}
				else {
					if ($ref->{'G'} eq $artG) {
						$leitud = 1;
					}
				}
			}
		}
		elsif ($elm_xpath eq '0') { # esimene
			$ting = "WHERE vol_nr = ${vNr} ORDER BY ms_att_OO ASC LIMIT 1";
			$sqlCmd = "SELECT ${DIC_DESC}.art AS art, ${DIC_DESC}.G AS G FROM ${DIC_DESC} $ting";
			$sth = $dbh->prepare($sqlCmd);
			$sth->execute();
			if (my $ref = $sth->fetchrow_hashref()) {
				$art = $ref->{'art'};
			}
		}
		elsif ($elm_xpath eq '1000000') { # viimane
			$ting = "WHERE vol_nr = ${vNr} ORDER BY ms_att_OO DESC LIMIT 1";
			$sqlCmd = "SELECT ${DIC_DESC}.art AS art, ${DIC_DESC}.G AS G FROM ${DIC_DESC} $ting";
			$sth = $dbh->prepare($sqlCmd);
			$sth->execute();
			if (my $ref = $sth->fetchrow_hashref()) {
				$art = $ref->{'art'};
			}
		}
		$sth->finish();
		$dbh->disconnect();
		
		$rsp_vol_node->appendTextNode($dicVol);
		$rsp_status_node->appendTextNode("Success");
		if ($art) {
			my $artDom = $dicparser->parse_string(decode_utf8($art));
			$rsp_count_node->appendTextNode(1);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($artDom->documentElement()));
		}
		else {
			$rsp_count_node->appendTextNode(0);
		}
	}
	else {
		my $xmlFile = "__sr/${DIC_DESC}/${dicVol}.xml";
		if (open(XMLF, '<:utf8', $xmlFile)) {
	#		if (flock(XMLF, $lockType)) {
				$dicDOM = $dicparser->parse_file($xmlFile);
				my $nodes = $dicDOM->documentElement()->findnodes($art_xpath);
				$rsp_vol_node->appendTextNode($dicVol);
				$rsp_status_node->appendTextNode("Success");
				$rsp_count_node->appendTextNode($nodes->size());
				if ($nodes->size() == 1) {
					$responseDOM->documentElement()->appendChild($responseDOM->importNode($nodes->get_node(1)));
				}
	#		}
	#		else {
	#			$rsp_status_node->appendTextNode("Failed to flock '${xmlFile}' (${cmdId})!");
	#		}
			close(XMLF);
		}
		else {
			$rsp_status_node->appendTextNode("Failed to open '${xmlFile}' (${cmdId})!");
		}
	}
}
elsif ($cmdId eq "tyhjadViited") {
	if ($qryMethod eq 'MySql') {
		my ($viitedXSL, $viiteXslNode);

		$viitedXSL = $dicparser->parse_file('xsl/viited.xsl');
		$viitedXSL->documentElement()->setNamespace($DICURI, 'al', 0);
		$viitedXSL->documentElement()->setNamespace($DICURI, $DICPR, 0);

		my $viiteQn = $seldQn;
		my $viiteLn = substr($viiteQn, index($viiteQn, ':') + 1);

		$viiteXslNode = $viitedXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/xsl:variable[\@name = 'marksonad']/xsl:for-each[\@select = 'siinTulebAsendada']")->get_node(1);
		$viiteXslNode->setAttribute("select", substr($default_query, index($default_query, '/') + 1));
		$viiteXslNode = $viitedXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/md/e")->get_node(1);
		$viiteXslNode->setAttribute("select", $qn_ms);

		$elm_xpath = ".//${viiteQn}";
		$art_xpath = "${DICPR}:A[${elm_xpath}]";
		$viiteXslNode = $viitedXSL->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/sr/xsl:apply-templates")->get_node(1);
		$viiteXslNode->setAttribute("select", $art_xpath);

		$viiteXslNode = $viitedXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/l/xsl:for-each")->get_node(1);
		$viiteXslNode->setAttribute("select", $elm_xpath);

		my $ss = $xslt->parse_stylesheet($viitedXSL);


		if ($dicVol eq "${DIC_DESC}All") {
			$i = 1;
			$j = $DIC_VOLS_COUNT;
		}
		else {
			$i = substr($dicVol, 3, 1);
			$j = $i;
		}

		my $qrycount = 0;
		my $puuduvaidViiteid = 0;
		my $lastG = '';
		my $lastVol = '';

		my $dbh = DBI->connect("DBI:mysql:database=${mySqlDbName};mysql_enable_utf8=1;host=192.168.11.11",
							 "eelex", "EELex",
							 {'RaiseError' => 0, AutoCommit => 0});

		my $artLeiuNr;
		my $respStr = "<sr>";

		my $whClause = "msid.dic_code = '${DIC_DESC}' AND msid.vol_nr > 0 AND msid.ms = BINARY ? AND IFNULL(msid.ms_att_i, -1) = ?";
		my $sth2 = $dbh->prepare("SELECT msid.ms AS ms, msid.ms_att_i AS ms_att_i FROM msid WHERE ${whClause}");

		for ($i; $i <= $j; $i++) {
			my $xmlFile = "__sr/${DIC_DESC}/${DIC_DESC}${i}.xml";

			if (open(XMLF, '<:utf8', $xmlFile)) {
				$dicDOM = $dicparser->parse_file($xmlFile);
				$qryDOM = $ss->transform($dicDOM, vf => "'${DIC_DESC}${i}'");
				$nStatus = 1;
				close(XMLF);
			}
			else {
				$nStatus = 0;
			}
			if ($nStatus == 1) {
				foreach my $vArt ($qryDOM->documentElement()->childNodes) {
					my $md = $vArt->findvalue("md/t");
					my $K = $vArt->findvalue("K");
					my $T = $vArt->findvalue("T");
					my $TA = $vArt->findvalue("TA");
					my $PT = $vArt->findvalue("PT");
					my $g = $vArt->findvalue("G");
					my $vol_nr = $i;

					$lastG = $g;
					$lastVol = $vol_nr;

					$artLeiuNr = 0;

					my $viitedList = $vArt->findnodes("l/${viiteQn}");
					for (my $ixViide = 1; $ixViide <= $viitedList->size(); $ixViide++) {
						my $viiteNode = $viitedList->get_node($ixViide);
						my $vXml = '';
						foreach my $vText ($viiteNode->findnodes('text()')) {
							$vXml .= $vText->toString; #nt textContent - '&amp;' -> '&', aga md salvestada XML moodi
						}
						# '<mvt>  -viide märksõnale; <lvt> - SP-s viide pereliikmele
						my $homNrVal = $viiteNode->getAttribute("${DICPR}:iv");
						unless ($homNrVal) {
							$homNrVal = $viiteNode->findvalue("${DICPR}:vhom");
						}
						unless ($homNrVal) {
							#	'sõnaperedes ja SS1-s <mvt> küljes
							$homNrVal = $viiteNode->getAttribute("${DICPR}:i");
						}
						my $ms_att_i = -1;
						if ($homNrVal) {
							$ms_att_i = $homNrVal;
						}

						my $iCnt = $sth2->execute($vXml, $ms_att_i);

						# järelkontroll "COLLATE=utf8_estonian_ci" pärast ..., (a = A ning tagatühikud puhuvad pilli)
						# LIKE BINARY v BINARY str tulemus sõltub kontekstist, vahel indeksit kasutada ei saa;
						# antud juhul peab BINARY olema argumendi, mitte msid.ms ees
#						my $eiLeitud = 1;
#						if ($iCnt > 0) {
#							while (my $ref = $sth2->fetchrow_hashref()) {
#								my $ms = decode_utf8($ref->{'ms'});
#								if ($ms eq $vXml) {
#									$eiLeitud = 0;
#									last;
#								}
#							}
#						}

						if ($iCnt < 1) {
							$artLeiuNr++;
							$puuduvaidViiteid++;
							$respStr .= '<A>';
								$respStr .= "<vf>${DIC_DESC}" . $vol_nr . "</vf>";
								$respStr .= "<md>";
									$respStr .= "<t>" . $md . "</t>";
								$respStr .= "</md>";
								$respStr .= "<K>" . $K . "</K>";
								$respStr .= "<T>" . $T . "</T>";
								$respStr .= "<TA>" . $TA . "</TA>";
								$respStr .= "<PT>" . $PT . "</PT>";
								$respStr .= "<G>" . $g . "</G>";
								$respStr .= "<l><t>";
									$respStr .= "<span class='_b' nr='${artLeiuNr}'>‹${viiteLn}";
										foreach my $attNode ($viiteNode->attributes()) {
											unless ($attNode->nodeName eq "${DICPR}:O" || $attNode->nodeName eq "xml:lang") {
												$respStr .= ' ▫' . $attNode->localname . '="' . $attNode->textContent . '"';
											}
										}
										$respStr .= "›</span>";
									$respStr .= " ▪${vXml}";
								$respStr .= '</t></l>';
							$respStr .= '</A>';
						}
					} # for $ixViide
					if ($artLeiuNr) {
						$qrycount++;
					}
				} # foreach my $vArt
			} # if $nStatus
			unless ($nStatus == 1) {
				last;
			}
		} # for $i
		$sth2->finish();
		$respStr .= "</sr>";

		$rsp_count_node->appendTextNode($qrycount);
		$rsp_status_node->appendTextNode("Success");

		# $outDOM->documentElement()->setAttribute("qfID", $queryFileID);
		$outDOM->documentElement()->setAttribute("qinfo", $qinfo);
		$outDOM->documentElement()->setAttribute("leide", $puuduvaidViiteid);

		if ($qrycount == 1) {
			$sqlCmd = "SELECT ${DIC_DESC}.art AS art FROM ${DIC_DESC} WHERE ${DIC_DESC}.G = '${lastG}' AND ${DIC_DESC}.vol_nr = ${lastVol}";
			my $sth = $dbh->prepare($sqlCmd);
			my $artCnt = $sth->execute();
			if ($artCnt == 1) {
				if (my $ref = $sth->fetchrow_hashref()) {
					my $artDom = $dicparser->parse_string(decode_utf8($ref->{'art'}));
					$dicVol = "${DIC_DESC}${lastVol}"; # selle järgi sätitakse ka köidete loend vastavale köitele
					$rsp_vol_node->appendTextNode($dicVol);
					$responseDOM->documentElement()->appendChild($responseDOM->importNode($artDom->documentElement()));
				}
			}
		}
		elsif ($qrycount > 1) {
			$qryDOM = $dicparser->parse_string($respStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($qryDOM->documentElement()));
			my $brInfoDom = $dicparser->parse_string($browseInfoStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($brInfoDom->documentElement()));
			# $outDOM->toFile("temp/${queryFileID}.xml", 0);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($outDOM->documentElement()));
		}

		$dbh->disconnect();

	} # if 'MySql'
	else {
		$rsp_count_node->appendTextNode(-1);
		$rsp_status_node->appendTextNode("Success");
	}
}
elsif ($cmdId eq "msSarnased") {
	if ($qryMethod eq 'MySql') {

		my $dbh = DBI->connect("DBI:mysql:database=${mySqlDbName};mysql_enable_utf8=1;host=192.168.11.11",
							 "eelex", "EELex",
							 {'RaiseError' => 1});

		my $volCond = '= ' . substr($dicVol, 3, 1);
		if ($dicVol eq "${DIC_DESC}All") {
			$volCond = '> 0';
		}
		
		my $sth;
		my $leide = 0;
		my $respStr = "<sr>";
		
		my $msNosCount = $dbh->do("CREATE TEMPORARY TABLE tt (SELECT * FROM msid WHERE (msid.dic_code = '${DIC_DESC}' AND msid.vol_nr ${volCond}) GROUP BY ms_nos HAVING COUNT(msid.ms_nos) > 1)");

		$sqlCmd = "SELECT 
			${DIC_DESC}.md AS md, 
			msid.ms AS l, 
			msid.ms_att_i AS ms_att_i, 
			msid.ms_att_liik AS ms_att_liik, 
			msid.ms_att_ps AS ms_att_ps, 
			msid.ms_att_tyyp AS ms_att_tyyp, 
			msid.ms_att_mliik AS ms_att_mliik, 
			msid.ms_att_k AS ms_att_k, 
			msid.ms_att_mm AS ms_att_mm, 
			msid.ms_att_st AS ms_att_st, 
			msid.ms_att_vm AS ms_att_vm, 
			msid.ms_att_all AS ms_att_all, 
			msid.ms_att_uus AS ms_att_uus, 
			msid.ms_att_zs AS ms_att_zs, 
			msid.ms_att_u AS ms_att_u, 
			msid.ms_att_em AS ms_att_em, 
			${DIC_DESC}.G AS G, 
			${DIC_DESC}.art AS art, 
			${DIC_DESC}.K AS K, 
			${DIC_DESC}.T AS T, 
			${DIC_DESC}.TA AS TA, 
			${DIC_DESC}.PT AS PT, 
			${DIC_DESC}.vol_nr AS vol_nr 
			FROM msid, ${DIC_DESC}, tt 
			WHERE ( ${DIC_DESC}.G = msid.G 
				AND msid.dic_code = '${DIC_DESC}' 
				AND msid.ms_nos = tt.ms_nos
				AND msid.vol_nr ${volCond} ) 
			ORDER BY msid.ms_nos";

		$sqlCmd =~ s/\s+/ /g;
		$sth = $dbh->prepare($sqlCmd);
		$sth->execute();
		$artsCount = -1;
		$leide = $sth->rows; # $qrycount on tegelikult leidude arv, kui küsitakse märksõnu
		unless ($leide > $MAX_PRINT_ARTS) {
			$respStr .= teeXMLStr($sth, '');
		}

		$respStr .= "</sr>";
		
		$sth->finish();
		$dbh->disconnect();

		$rsp_count_node->appendTextNode($artsCount);
		$rsp_status_node->appendTextNode("Success");

		# $outDOM->documentElement()->setAttribute("qfID", $queryFileID);
		$outDOM->documentElement()->setAttribute("qinfo", $qinfo);
		$outDOM->documentElement()->setAttribute("leide", $leide);

		if ($artsCount == 1) {
			my $artDom = $dicparser->parse_string($viimaneArt);
			$dicVol = "${DIC_DESC}${viimane_vol_nr}"; # selle järgi sätitakse ka köidete loend vastavale köitele
			$rsp_vol_node->appendTextNode($dicVol);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($artDom->documentElement()));
		}
		elsif ($artsCount > 1 || $artsCount == -1) {
			$qryDOM = $dicparser->parse_string($respStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($qryDOM->documentElement()));
			my $brInfoDom = $dicparser->parse_string($browseInfoStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($brInfoDom->documentElement()));
			# $outDOM->toFile("temp/${queryFileID}.xml", 0);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($outDOM->documentElement()));
		}
	}
	else {
		$rsp_count_node->appendTextNode(-1);
		$rsp_status_node->appendTextNode("Success");
	}
}
elsif ($cmdId eq "ClientRead") {

	if ($qryMethod eq 'MySql') {

		my $dbh = DBI->connect("DBI:mysql:database=${mySqlDbName};mysql_enable_utf8=1;host=192.168.11.11",
							 "eelex", "EELex",
							 {'RaiseError' => 1});

		my $volCond = '= ' . substr($dicVol, 3, 1);
		if ($dicVol eq "${DIC_DESC}All") {
			$volCond = '> 0';
		}
		
		my $sth;
		my $leide = 0;
		my $respStr = "<sr>";

		if ($seldQn eq $qn_ms && $msO > 0) { # msO - ms otsing
			my $rexBinary = '';
			if ($withCase eq '1') {
				$rexBinary = 'BINARY';
			}
			my $msFieldCond = "msid.ms LIKE ${rexBinary} " . $dbh->quote($mySqlLikePtrn);
			if ($withSymbols eq '0') {
				$msFieldCond = "msid.ms_nos LIKE ${rexBinary} '${mySqlLikePtrn}'";
				if ($fakPtrn) {
					$msFieldCond .= " OR msid.ms_nos_alt LIKE ${rexBinary} '${mySqlLikePtrn}'";
				}
			}
			my $msCond = '';
			if ($msO == 2) { # praegu (28jaan11) pole ...
				$msCond = "AND (msid.ms = \"${fMySQLPtrn}\")";
			}
			elsif ($fMySQLPtrn eq '') {
				$msCond = "AND (msid.ms = '')";
			}
			elsif ($fMySQLPtrn eq '.*') { # ms '*' korral
			}
			else {
				$msCond = "AND (${msFieldCond})";
			}
			$sqlCmd = "SELECT 
				${DIC_DESC}.md AS md, 
				msid.ms AS l, 
				msid.ms_att_i AS ms_att_i, 
				msid.ms_att_liik AS ms_att_liik, 
				msid.ms_att_ps AS ms_att_ps, 
				msid.ms_att_tyyp AS ms_att_tyyp, 
				msid.ms_att_mliik AS ms_att_mliik, 
				msid.ms_att_k AS ms_att_k, 
				msid.ms_att_mm AS ms_att_mm, 
				msid.ms_att_st AS ms_att_st, 
				msid.ms_att_vm AS ms_att_vm, 
				msid.ms_att_all AS ms_att_all, 
				msid.ms_att_uus AS ms_att_uus, 
				msid.ms_att_zs AS ms_att_zs, 
				msid.ms_att_u AS ms_att_u, 
				msid.ms_att_em AS ms_att_em, 
				${DIC_DESC}.G AS G, 
				${DIC_DESC}.art AS art, 
				${DIC_DESC}.K AS K, 
				${DIC_DESC}.T AS T, 
				${DIC_DESC}.TA AS TA, 
				${DIC_DESC}.PT AS PT, 
				${DIC_DESC}.vol_nr AS vol_nr 
				FROM msid, ${DIC_DESC} 
				WHERE ( ${DIC_DESC}.G = msid.G 
					AND msid.dic_code = '${DIC_DESC}' 
					${msCond} 
					${msAttCond} 
					AND msid.vol_nr ${volCond} ) 
				ORDER BY ${DIC_DESC}.ms_att_OO";
			$sqlCmd =~ s/\s+/ /g;
			$sth = $dbh->prepare($sqlCmd);
			$sth->execute();
			$artsCount = -1;
			$leide = $sth->rows; # $qrycount on tegelikult leidude arv, kui küsitakse märksõnu

			$respStr .= teeXMLStr($sth, '');

#			unless ($leide > $MAX_PRINT_ARTS) {
#				$respStr .= teeXMLStr($sth, '');
#			}

		}
		else {
			my $artFieldName = 'art';
			# kui fMySQLPtrn on tühi, on teostatud '*' otsingut mingil elemendil, mis ei ole märksõna
			if ($withSymbols eq '0' && $fMySQLPtrn) {
				$artFieldName = 'art_alt';
			}
			$sqlCmd = "SELECT 
				${DIC_DESC}.md AS md, 
				ExtractValue(${DIC_DESC}.art, \"${evPath}\") AS l, 
				${DIC_DESC}.G AS G, 
				${DIC_DESC}.art AS art, 
				${DIC_DESC}.K AS K, 
				${DIC_DESC}.T AS T, 
				${DIC_DESC}.TA AS TA, 
				${DIC_DESC}.PT AS PT, 
				${DIC_DESC}.vol_nr AS vol_nr 
				FROM ${DIC_DESC} 
				WHERE ( getFromXML(${DIC_DESC}.${artFieldName}, \"${getFrXmlPath}\", '${fMySQLPtrn}', ${withCase}) > 0 
					AND ${DIC_DESC}.vol_nr ${volCond} ) 
				ORDER BY ${DIC_DESC}.ms_att_OO";
			$sqlCmd =~ s/\s+/ /g;
			$sth = $dbh->prepare($sqlCmd);
			$sth->execute();
			$artsCount = $sth->rows;
			$leide = '-1';

			$respStr .= teeXMLStr($sth, 'Σ ');

#			unless ($artsCount > $MAX_PRINT_ARTS) {
#				$respStr .= teeXMLStr($sth, 'Σ ');
#			}

		}

		$respStr .= "</sr>";
		
		$sth->finish();
		$dbh->disconnect();

		$rsp_count_node->appendTextNode($artsCount);
		$rsp_status_node->appendTextNode("Success");

		# $outDOM->documentElement()->setAttribute("qfID", $queryFileID);
		$outDOM->documentElement()->setAttribute("qinfo", $qinfo);
		$outDOM->documentElement()->setAttribute("leide", $leide);

		if ($artsCount == 1) {
			my $artDom = $dicparser->parse_string($viimaneArt);
			$dicVol = "${DIC_DESC}${viimane_vol_nr}"; # selle järgi sätitakse ka köidete loend vastavale köitele
			$rsp_vol_node->appendTextNode($dicVol);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($artDom->documentElement()));
		}
		elsif ($artsCount > 1 || $artsCount == -1) {
			$qryDOM = $dicparser->parse_string($respStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($qryDOM->documentElement()));
			my $brInfoDom = $dicparser->parse_string($browseInfoStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($brInfoDom->documentElement()));
			# $outDOM->toFile("temp/${queryFileID}.xml", 0);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($outDOM->documentElement()));
		}
	}
	else { # 'ClientRead': qM eq 'XML'

		$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/sr/xsl:apply-templates")->get_node(1);
		$xslnode->setAttribute("select", $art_xpath);

		$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/l/t/xsl:for-each")->get_node(1);
		$xslnode->setAttribute("select", $elm_xpath);

		my $ss = $xslt->parse_stylesheet($queryXSL);
	    
		# artikleid
		my $qrycount = 0;
		# leide
		my $leide = 0;
		my $qryguid;
		my $qryart;
		my $xmlFile;
		
		if ($dicVol eq "${DIC_DESC}All") {
			$i = 1;
			$j = $DIC_VOLS_COUNT;
		}
		else {
			$i = substr($dicVol, 3, 1);
			$j = $i;
		}

		my $lisatud = 0;

		for ($i; $i <= $j; $i++) {
		
			$xmlFile = "__sr/${DIC_DESC}/${DIC_DESC}${i}.xml";

			if (open(XMLF, '<:utf8', $xmlFile)) {
	#			if (flock(XMLF, $lockType)) {
					$dicDOM = $dicparser->parse_file($xmlFile);
					$qryDOM = $ss->transform($dicDOM, vf => "'${DIC_DESC}${i}'");
	#				flock(XMLF, LOCK_UN);
					$nStatus = 1;
	#			}
				close(XMLF);
			}
			if ($nStatus) {
				$artsCount = $qryDOM->documentElement()->childNodes->size(); # <A> - de hulk (sr/A)
				$qrycount += $artsCount;
				$leide += $qryDOM->documentElement()->findnodes("A/l/t/span[\@class = '_b'][\@nr]")->size();

				if ($artsCount > 0) {
					if ($artsCount == 1) {
						$dicVol = "${DIC_DESC}${i}"; # selle järgi sätitakse ka köidete loend vastavale köitele
						$qryguid = $qryDOM->documentElement()->childNodes->get_node(1)->findvalue('G');
						$qryart = $dicDOM->documentElement()->findnodes("${DICPR}:A[${DICPR}:G = '${qryguid}']")->get_node(1);
					}
					if ($lisatud < $MAX_PRINT_ARTS) {
						my $vahe = $artsCount;
						if ($artsCount + $lisatud > $MAX_PRINT_ARTS) {
							my $maxQryArtsXSLDom = $dicparser->parse_file('xsl/maxQryArts.xsl');
							my $ssMaxQryArts = $xslt->parse_stylesheet($maxQryArtsXSLDom);
							my $vahe = ($MAX_PRINT_ARTS - $lisatud);
							$qryDOM = $ssMaxQryArts->transform($qryDOM, maxNr => "'${vahe}'");
						}
						# outDOM/sr/A
						# mitu sr - i, $qryDOM - i mitte puutuda
						$outDOM->documentElement()->appendChild($outDOM->importNode($qryDOM->documentElement()));
						$lisatud += $vahe;
					}
				}
			}
			else {
				last;
			}
		}
		
		if ($nStatus) {
			$rsp_count_node->appendTextNode($qrycount);
			$rsp_status_node->appendTextNode("Success");

			# $outDOM->documentElement()->setAttribute("qfID", $queryFileID);
			$outDOM->documentElement()->setAttribute("qinfo", $qinfo);
			$outDOM->documentElement()->setAttribute("leide", $leide);

			if ($qrycount == 1) {
				$rsp_vol_node->appendTextNode($dicVol); # selle järgi sätitakse ka köidete loend vastavale köitele
				$responseDOM->documentElement()->appendChild($responseDOM->importNode($qryart));
			}
			elsif ($qrycount > 1) {
				# $outDOM->toFile("temp/${queryFileID}.xml", 0);
				my $brInfoDom = $dicparser->parse_string($browseInfoStr);
				$outDOM->documentElement()->appendChild($brInfoDom->documentElement());
				$responseDOM->documentElement()->appendChild($responseDOM->importNode($outDOM->documentElement()));
			}
		}
		else {
	#		$rsp_status_node->appendTextNode("Failed to open/flock '${xmlFile}' (${cmdId})!");
			$rsp_status_node->appendTextNode("Failed to open '${xmlFile}' (${cmdId})!");
		}
	}
}
elsif (($cmdId eq "ClientWrite") && $nEditAllowed) {

	my $dbh;
	my $srLang;
	my ($vNr, $vanaA);
	my ($fh, $xmlFile, $backupFile);

	$vNr = substr($dicVol, 3, 1);

# - algus
	if ($qryMethod eq 'MySql') {
		$dbh = DBI->connect("DBI:mysql:database=${mySqlDbName};mysql_enable_utf8=1;host=192.168.11.11",
							 "eelex", "EELex",
							 {'RaiseError' => 0, AutoCommit => 1});
		my $sth = $dbh->prepare("SELECT ${DIC_DESC}.art AS art FROM ${DIC_DESC} WHERE ${DIC_DESC}.G = '${artG}'");
		$sth->execute();
		my $artCnt = $sth->rows;
		if ($artCnt == 1) {
			if (my $ref = $sth->fetchrow_hashref()) {
				$vanaA = $dicparser->parse_string($ref->{'art'})->documentElement();
				$nStatus = 1;
			}
		}
		else {
			$rsp_status_node->appendTextNode("Failed on select ... where G = '${artG}' (${artCnt} tk) (${cmdId})!");
		}
		$sth->finish();
	}
	else {
		$nStatus = 1;
	}
	
	if ($nStatus == 1) {
		$xmlFile = "__sr/${DIC_DESC}/${dicVol}.xml";
		$backupFile = "backup/${dicVol}.xml";
		my $nodes;
		if (open($fh, '+<:utf8', $xmlFile)) {
			if (flock($fh, $lockType)) {
				$dicDOM = $dicparser->parse_file($xmlFile);
				$srLang = $dicDOM->documentElement()->getAttribute('xml:lang');
				$nodes = $dicDOM->documentElement()->findnodes("${DICPR}:A[${DICPR}:G = '${artG}']");
				if ($nodes->size() == 1) {
					$vanaA = $nodes->get_node(1);
					$nStatus = 2;
				}
				else {
					$rsp_status_node->appendTextNode("Failed on 'findnodes(G = ${artG})' (" . $nodes->size() . " tk) (${cmdId})!");
				}
			}
			else {
				$rsp_status_node->appendTextNode("Failed to flock '${xmlFile}' (${cmdId})!");
			}
		}
		else {
			$rsp_status_node->appendTextNode("Failed to open '${xmlFile}' (${cmdId})!");
		}
	}
	unless ($srLang) {
		$srLang = 'et';
	}


	#vanaA on nüüd käes
	my ($vanaT, $vanaTA, $vanaO, $uusA, $uusT, $uusTA, $uusO);
	if ($nStatus == 2) {

		$vanaT = $vanaA->findvalue("${DICPR}:T");
		$vanaTA = $vanaA->findvalue("${DICPR}:TA");
		$vanaO = $vanaA->findvalue("${fdArt}/\@${DICPR}:O");

		$uusA = $prmDOM->documentElement()->findnodes("${DICPR}:A")->get_node(1);
		$uusT = $uusA->findvalue("${DICPR}:T");
		$uusTA = $uusA->findvalue("${DICPR}:TA");
		$uusO = $uusA->findvalue("${fdArt}/\@${DICPR}:O");
		
		if ($uusTA eq $vanaTA) {
			$nStatus = 3;
		}
		else { #nt 'Undo' korral ei ole ajad võrdsed
			if ($uusT eq $vanaT) {
				$nStatus = 3;
			}
			else {
				$rsp_status_node->appendTextNode("Serveris on artiklist olemas juba uuem versioon (${cmdId})!");
			}
		}
	}

	#võib nüüd salvestada - kui vaja, andmed käes ja ei ole vahepeal keegi üle kirjutanud
	my $sth;
	if ($nStatus == 3) {

		my $m1Elem = $uusA->findnodes("${fdArt}")->get_node(1);
		$opMs = $m1Elem->textContent;
		foreach my $attNode ($m1Elem->attributes()) {
			if ($attNode->localname ne 'O') {
				$opAttrs .= " \@" . $attNode->nodeName . "='" . $attNode->textContent . "'";
			}
		}
		$opAttrs = substr($opAttrs, 1);

		my $refNode;
		my $toimetajaNode = $uusA->findnodes("${DICPR}:T")->get_node(1);
		unless ($toimetajaNode) {
			$refNode = $uusA->findnodes("${DICPR}:TA | ${DICPR}:TL | ${DICPR}:PT | ${DICPR}:PTA | ${DICPR}:X | ${DICPR}:XA")->get_node(1);
			$toimetajaNode = $uusA->insertBefore($prmDOM->createElement("${DICPR}:T"), $refNode);
			$toimetajaNode->appendTextNode('-');
		}
		$toimetajaNode->firstChild->setData($usrName);
		my $tkpNode = $uusA->findnodes("${DICPR}:TA")->get_node(1);
		unless ($tkpNode) {
			$refNode = $uusA->findnodes("${DICPR}:TL | ${DICPR}:PT | ${DICPR}:PTA | ${DICPR}:X | ${DICPR}:XA")->get_node(1);
			$tkpNode = $uusA->insertBefore($prmDOM->createElement("${DICPR}:TA"), $refNode);
			$tkpNode->appendTextNode('-');
		}
		$tkpNode->firstChild->setData($nowdtstr);

		if ($qryMethod eq 'MySql') {
			my ($md, $mTekstid, $TA, $ms_lang, $ms_nos, $rcnt, $ms_att_OO);
			$md = '';

			if ($uusO ne $vanaO) {
				$sth = $dbh->prepare("SELECT * FROM ${DIC_DESC} WHERE ${DIC_DESC}.vol_nr = ${vNr} AND ${DIC_DESC}.ms_att_O = '${uusO}'");
				$sth->execute();
				my $notUniqueNodesCnt = $sth->rows;
				$sth->finish();
				if ($notUniqueNodesCnt > 0) {
					goto trahh;
				}
			}
			
			$dbh->begin_work; #AutoCommit
			
			my $delCmd = "DELETE FROM msid WHERE dic_code = '${DIC_DESC}' AND G = '${artG}'";
			$sth = $dbh->prepare($delCmd);
			$rcnt = $sth->execute();
			if ($rcnt > 0) {
				# märksõnad globaalselt; VSL-is on nt märksõnad ka nn allartiklis <AA>
				foreach my $mElem ($uusA->findnodes(".//${qn_ms}")) {
					$mTekstid = '';
					foreach my $mText ($mElem->findnodes('text()')) {
						$mTekstid .= $mText->toString; #nt textContent - '&amp;' -> '&', aga md salvestada XML moodi
					}
					$ms_lang = $mElem->getAttribute('xml:lang');
					unless ($ms_lang) {
						$ms_lang = $srLang;
					}
					my $insCmd = "INSERT INTO MSID SET ";
					foreach my $attNode ($mElem->attributes()) {
						unless ($attNode->nodeName eq 'xml:lang') {
							#NB: siin 'textContent'
							$insCmd .= "ms_att_" . $attNode->localname . " = '" . $attNode->textContent . "', ";
						}
					}
					if ($fakOlemas) {
						if (index($mTekstid, substr($fakOlemas, 0, 1)) > -1 && index($mTekstid, substr($fakOlemas, 1, 1)) > -1) {
							my $fakOsata = $mTekstid;
							$fakOsata =~ s/$fakOsataPtrn//g; #sulud ja tema sees olev maha
							# &amp; , muutujad + mittetähed , tõlkimine
							$fakOsata = teeMs_nosKuju($fakOsata);
							$insCmd .= "ms_nos_alt = '${fakOsata}', ";
						}
					}
					$ms_att_OO = $mElem->getAttribute("${DICPR}:O");
					$ms_att_OO =~ tr/\^0123456789_\%\+\/\|AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsŠšZzŽžTtUuVvWwÕõÄäÖöÜüXxYy/\x{E001}\x{E002}\x{E003}\x{E004}\x{E005}\x{E006}\x{E007}\x{E008}\x{E009}\x{E00A}\x{E00B}\x{E00C}\x{E00D}\x{E00E}\x{E00F}\x{E010}\x{E011}\x{E011}\x{E013}\x{E013}\x{E015}\x{E015}\x{E017}\x{E017}\x{E019}\x{E019}\x{E01B}\x{E01B}\x{E01D}\x{E01D}\x{E01F}\x{E01F}\x{E021}\x{E021}\x{E023}\x{E023}\x{E025}\x{E025}\x{E027}\x{E027}\x{E029}\x{E029}\x{E02B}\x{E02B}\x{E02D}\x{E02D}\x{E02F}\x{E02F}\x{E031}\x{E031}\x{E033}\x{E033}\x{E035}\x{E035}\x{E037}\x{E037}\x{E039}\x{E039}\x{E03B}\x{E03B}\x{E03D}\x{E03D}\x{E03F}\x{E03F}\x{E041}\x{E041}\x{E043}\x{E043}\x{E045}\x{E045}\x{E047}\x{E047}\x{E049}\x{E049}\x{E04B}\x{E04B}\x{E04D}\x{E04D}\x{E04F}\x{E04F}/d;
					# &amp; , muutujad + mittetähed , tõlkimine
					$ms_nos = teeMs_nosKuju($mTekstid);
					$insCmd .= "ms_att_OO = '${ms_att_OO}', 
								ms_lang = '${ms_lang}', 
								dic_code = '${DIC_DESC}', 
								vol_nr = ${vNr}, 
								ms = " . $dbh->quote($mTekstid) . " , 
								ms_nos = '${ms_nos}', 
								G = '${artG}'";
					$sth = $dbh->prepare($insCmd);
					$rcnt = $sth->execute();
					unless ($rcnt == 1) {
						$rsp_status_node->appendTextNode($sth->errstr . ' :: ' . $insCmd);
						$dbh->rollback;
						last;
					}
					if ($md) {
						$md .= ' :: ';
					}
					$md .= $mTekstid;
				}
				
				if ($rcnt == 1) {
					$TA = $nowdtstr;
					$TA =~ s/T/ /g;

					$ms_att_OO = $uusO;
					$ms_att_OO =~ tr/\^0123456789_\%\+\/\|AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsŠšZzŽžTtUuVvWwÕõÄäÖöÜüXxYy/\x{E001}\x{E002}\x{E003}\x{E004}\x{E005}\x{E006}\x{E007}\x{E008}\x{E009}\x{E00A}\x{E00B}\x{E00C}\x{E00D}\x{E00E}\x{E00F}\x{E010}\x{E011}\x{E011}\x{E013}\x{E013}\x{E015}\x{E015}\x{E017}\x{E017}\x{E019}\x{E019}\x{E01B}\x{E01B}\x{E01D}\x{E01D}\x{E01F}\x{E01F}\x{E021}\x{E021}\x{E023}\x{E023}\x{E025}\x{E025}\x{E027}\x{E027}\x{E029}\x{E029}\x{E02B}\x{E02B}\x{E02D}\x{E02D}\x{E02F}\x{E02F}\x{E031}\x{E031}\x{E033}\x{E033}\x{E035}\x{E035}\x{E037}\x{E037}\x{E039}\x{E039}\x{E03B}\x{E03B}\x{E03D}\x{E03D}\x{E03F}\x{E03F}\x{E041}\x{E041}\x{E043}\x{E043}\x{E045}\x{E045}\x{E047}\x{E047}\x{E049}\x{E049}\x{E04B}\x{E04B}\x{E04D}\x{E04D}\x{E04F}\x{E04F}/d;
					my $updCmd = "UPDATE ${DIC_DESC} SET md = " . $dbh->quote($md) . ", ms_att_O = '${uusO}', ms_att_OO = '${ms_att_OO}'";
					my $KL = $uusA->findvalue("${DICPR}:KL");
					if ($KL) {
						$KL =~ s/T/ /g;
						$updCmd .= ", KL = '${KL}'";
					}
					else {
						$updCmd .= ", KL = NULL";
					}
					$updCmd .= ", T = '${usrName}', TA = '${TA}'";
					my $TL = $uusA->findvalue("${DICPR}:TL");
					if ($TL) {
						$TL =~ s/T/ /g;
						$updCmd .= ", TL = '${TL}'";
					}
					else {
						$updCmd .= ", TL = NULL";
					}
					my $PT = $uusA->findvalue("${DICPR}:PT");
					if ($PT) {
						$updCmd .= ", PT = '${PT}'";
					}
					else {
						$updCmd .= ", PT = NULL";
					}
					my $PTA = $uusA->findvalue("${DICPR}:PTA");
					if ($PTA) {
						$PTA =~ s/T/ /g;
						$updCmd .= ", PTA = '${PTA}'";
					}
					else {
						$updCmd .= ", PTA = NULL";
					}
					my $uusXml = $uusA->toString;
					my $artKoopiaDom = XML::LibXML::Document->createDocument( "1.0", "UTF-8" );
					$artKoopiaDom->setDocumentElement($artKoopiaDom->importNode( $uusA->cloneNode(1) ));
					my $uusAKoopia = $artKoopiaDom->documentElement();
					foreach my $tekst ($uusAKoopia->findnodes(".//text()")) {
						my $juhhei = $tekst->toString;
						# &amp; , muutujad + mittetähed , tõlkimine
						$juhhei = teeMs_nosKuju($juhhei);
						$tekst->setData($juhhei);
					}
					my $uusAltXml = $uusAKoopia->toString;
					$updCmd .= ", art = " . $dbh->quote($uusXml) . ", art_alt = " . $dbh->quote($uusAltXml) . " WHERE ${DIC_DESC}.G = '${artG}'";
					
					$sth = $dbh->prepare($updCmd);
					$rcnt = $sth->execute();
					if ($rcnt == 1) {
						$dbh->commit;
						$nStatus = 4;
					}
					else {
						$rsp_status_node->appendTextNode($sth->errstr . ' :: ' . $updCmd);
						$dbh->rollback;
					}
				}
			}
			else {
				$rsp_status_node->appendTextNode($sth->errstr . ' :: ' . $delCmd);
				$dbh->rollback;
			}
		}
		else {
			# XML-i tuleb salvestada paralleelselt MySql-iga ...
			# aga XML puhul on veel unikaalsus kindlaks tegemata
			if ($vanaO ne $uusO) {
				# sellise päringu (translate()) peale läheb hirmus aeg: 20 s
				# my $notUniqueNodes = $dicDOM->documentElement()->findnodes("translate(${FIRST_DEFAULT}/\@${DICPR}:O, 'ABCDEFGHIJKLMNOPQRSŠZŽTUVWÕÄÖÜXY', 'abcdefghijklmnopqrsšzžtuvwõäöüxy') = '" . lc($uusO) . "'");
				# unikaalseks jäävad ainult esimesed märksõnad artiklis
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/sr/xsl:apply-templates")->get_node(1);
				$xslnode->setAttribute("select", "${DICPR}:A[${fdArt}/\@${DICPR}:O[al_p:srch(.) > 0]][${DICPR}:G != '${artG}']");
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/l/t/xsl:for-each")->get_node(1);
				$xslnode->setAttribute("select", 'self::node()');
				my $ss = $xslt->parse_stylesheet($queryXSL);
				$qryDOM = $ss->transform($dicDOM, vf => "'${dicVol}'");
				my $notUniqueNodesCnt = $qryDOM->documentElement()->childNodes->size();
				if ($notUniqueNodesCnt == 0) {
					$nStatus = 4;
				}
				else {
trahh:
					$rsp_status_node->appendTextNode($lcDom->documentElement()->findvalue("itm[\@n = 'HW_HOM_COMBINATION'][\@l = '${APP_LANG}']") . " (${fSrchPtrn}) (${cmdId})!");
				}
			}
			else {
				$nStatus = 4;
			}
		}
		#'dic_code' tabelis on 'ms_att_O' unikaalne, XML failis on 'O' unikaalne
		if ($nStatus == 4) {
			$dicDOM->documentElement()->replaceChild($dicDOM->importNode($uusA), $vanaA);
			if ($vanaO ne $uusO) {
				my $ss = $xslt->parse_stylesheet($sortXSL);
				$dicDOM = $ss->transform($dicDOM);
			}
			if ($dicDOM->toFile($backupFile, 0)) {
# Win32 all on iga thread omaette protsess, seepärast lock vabastada LibXML-le, muidu ei pääse ligi
				if ($^O eq 'MSWin32') {
					flock($fh, LOCK_UN);
				}
				if ($dicDOM->toFile($xmlFile, 0)) {
					$nStatus = 5;
				}
				else {
					$rsp_status_node->appendTextNode("Server error writing '${xmlFile}' file (${cmdId})! See admin!");
				}
			}
			else {
				$rsp_status_node->appendTextNode("Server error writing backup '${backupFile}' file (${cmdId})! Try again!");
			}
		}
	}

	#nüüd võib lõpetada. Kõik on salvestatud
	my $leide;
	if ($nStatus == 5) {
		if ($art_xpath) { #homonüümsed
			if ($qryMethod eq 'MySql') {
				$sth = $dbh->prepare($sql);
				$sth->execute();

				my $respStr = '<sr>';
				$artsCount = -1;
				$leide = $sth->rows;
				unless ($leide > $MAX_PRINT_ARTS) {
					$respStr .= teeXMLStr($sth, '');
				}
				$respStr .= "</sr>";
				$qryDOM = $dicparser->parse_string($respStr);
			}
			else {
				# art_xpath - "homonüümsete kontroll":  DICPR & ":A[" & elm_xpath & "]"
				# elm_xpath - "arttingimus": m[ sOrgMarkSona (or sMarkSona)]
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/sr/xsl:apply-templates")->get_node(1);
				$xslnode->setAttribute("select", $art_xpath);
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/l/t/xsl:for-each")->get_node(1);
				$xslnode->setAttribute("select", $elm_xpath);
				my $ss = $xslt->parse_stylesheet($queryXSL);
				$qryDOM = $ss->transform($dicDOM, vf => "'${dicVol}'");
				$artsCount = $qryDOM->documentElement()->childNodes->size();
				$leide = $qryDOM->documentElement()->findnodes("A/l/t/span[\@class = '_b'][\@nr]")->size();
			}
		}
		else {
			$artsCount = 1;
		}
	}

	if ($nStatus > 1) {
		flock($fh, LOCK_UN);
		close($fh);
	}

	$rsp_vol_node->appendTextNode($dicVol);
	if ($nStatus == 5) {

		$rsp_count_node->appendTextNode($artsCount);
		$rsp_status_node->appendTextNode("Success");

		if ($artsCount == 1) {
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($uusA));
		}
		else {
			# $outDOM->documentElement()->setAttribute("qfID", $queryFileID);
			$outDOM->documentElement()->setAttribute("qinfo", $lcDom->documentElement()->findvalue("itm[\@n = 'CHECK_HOMS'][\@l = '${APP_LANG}']") . ": '${opMs}'");
			$outDOM->documentElement()->setAttribute("leide", $leide);
			$outDOM->documentElement()->appendChild($outDOM->importNode($qryDOM->documentElement()));
			my $brInfoDom = $dicparser->parse_string($browseInfoStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($brInfoDom->documentElement()));
			# $outDOM->toFile("temp/${queryFileID}.xml", 0);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($outDOM->documentElement()));
		}
	}
	else {
		$rsp_count_node->appendTextNode('0');
	}

# - lõpetamine
	if ($qryMethod eq 'MySql') {
		$dbh->disconnect();
	}

}
elsif (($cmdId eq "ClientAdd") && $nEditAllowed) {

	my ($fh, $xmlFile, $backupFile);
	my $xmlFile = "__sr/${DIC_DESC}/${dicVol}.xml";
	my $backupFile = "backup/${dicVol}.xml";

	my $srLang;
	my ($dbh, $sth);

	if ($qryMethod eq 'MySql') {
		$dbh = DBI->connect("DBI:mysql:database=${mySqlDbName};mysql_enable_utf8=1;host=192.168.11.11",
							 "eelex", "EELex",
							 {'RaiseError' => 0, AutoCommit => 1});
		if ($dbh) {
			$nStatus = 1;
		}
		else {
			$rsp_status_node->appendTextNode($DBI::errstr . " :: Failed to connect to '${mySqlDbName}' (${cmdId})");
		}
	}
	else {
		$nStatus = 1;
	}

	if ($nStatus == 1) {
		if (open($fh, '+<:utf8', $xmlFile)) {
			if (flock($fh, $lockType)) {
				$dicDOM = $dicparser->parse_file($xmlFile);
				$srLang = $dicDOM->documentElement()->getAttribute('xml:lang');
				$nStatus = 3;
			}
			else {
				$rsp_status_node->appendTextNode("Failed to flock '${xmlFile}' (${cmdId})!");
			}
		}
		else {
			$rsp_status_node->appendTextNode("Failed to open '${xmlFile}' (${cmdId})!");
		}
	}
	unless ($srLang) {
		$srLang = 'et';
	}

# - algus
	#võib nüüd salvestada - kui vaja

	my ($uusA, $uusT, $uusTA, $uusO, $vNr);

	$vNr = substr($dicVol, 3, 1);

	if ($nStatus == 3) {
		use Data::GUID;
		my $newGuid = Data::GUID->new();

		$uusA = $prmDOM->documentElement()->findnodes("${DICPR}:A")->get_node(1);
		$uusT = $uusA->findvalue("${DICPR}:T");
		$uusTA = $uusA->findvalue("${DICPR}:TA");
		$uusO = $uusA->findvalue("${fdArt}/\@${DICPR}:O");

		my $m1Elem = $uusA->findnodes("${fdArt}")->get_node(1);
		$opMs = $m1Elem->textContent;
		foreach my $attNode ($m1Elem->attributes()) {
			if ($attNode->localname ne 'O') {
				$opAttrs .= " \@" . $attNode->nodeName . "='" . $attNode->textContent . "'";
			}
		}
		$opAttrs = substr($opAttrs, 1);

		my $guidNode = $uusA->findnodes("${DICPR}:G")->get_node(1);
		$guidNode->firstChild->setData($newGuid);
		my $autornode = $uusA->findnodes("${DICPR}:K")->get_node(1);
		$autornode->firstChild->setData($usrName);
		my $akpnode = $uusA->findnodes("${DICPR}:KA")->get_node(1);
		$akpnode->firstChild->setData($nowdtstr);
		my $toimetajanode = $uusA->findnodes("${DICPR}:T")->get_node(1);
		$toimetajanode->firstChild->setData($usrName);
		my $tkpnode = $uusA->findnodes("${DICPR}:TA")->get_node(1);
		$tkpnode->firstChild->setData($nowdtstr);

		if ($qryMethod eq 'MySql') {
			my ($md, $mTekstid, $TA, $ms_lang, $ms_nos, $rcnt, $ms_att_OO);
			$md = '';

			$sth = $dbh->prepare("SELECT * FROM ${DIC_DESC} WHERE ${DIC_DESC}.vol_nr = ${vNr} AND ${DIC_DESC}.ms_att_O = '${uusO}'");
			$sth->execute();
			my $notUniqueNodesCnt = $sth->rows;
			$sth->finish();
			if ($notUniqueNodesCnt > 0) {
				goto trahhAdd;
			}

			$dbh->begin_work; # autocommit == 0
			
			# märksõnad globaalselt; VSL-is on nt märksõnad ka nn allartiklis <AA>
			foreach my $mElem ($uusA->findnodes(".//${qn_ms}")) {
				$mTekstid = '';
				foreach my $mText ($mElem->findnodes('text()')) {
					$mTekstid .= $mText->toString;
				}
				$ms_lang = $mElem->getAttribute('xml:lang');
				unless ($ms_lang) {
					$ms_lang = $srLang;
				}
				my $insCmd = "INSERT INTO MSID SET ";
				foreach my $attNode ($mElem->attributes()) {
					unless ($attNode->nodeName eq 'xml:lang') {
						#NB: siin 'textContent'
						$insCmd .= "ms_att_" . $attNode->localname . " = '" . $attNode->textContent . "', ";
					}
				}
				if ($fakOlemas) {
					if (index($mTekstid, substr($fakOlemas, 0, 1)) > -1 && index($mTekstid, substr($fakOlemas, 1, 1)) > -1) {
						my $fakOsata = $mTekstid;
						$fakOsata =~ s/$fakOsataPtrn//g; #sulud ja tema sees olev maha
						# &amp; , mittetähed , tõlkimine
						$fakOsata = teeMs_nosKuju($fakOsata);
						$insCmd .= "ms_nos_alt = '${fakOsata}', ";
					}
				}
				$ms_att_OO = $mElem->getAttribute("${DICPR}:O");
				$ms_att_OO =~ tr/\^0123456789_\%\+\/\|AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsŠšZzŽžTtUuVvWwÕõÄäÖöÜüXxYy/\x{E001}\x{E002}\x{E003}\x{E004}\x{E005}\x{E006}\x{E007}\x{E008}\x{E009}\x{E00A}\x{E00B}\x{E00C}\x{E00D}\x{E00E}\x{E00F}\x{E010}\x{E011}\x{E011}\x{E013}\x{E013}\x{E015}\x{E015}\x{E017}\x{E017}\x{E019}\x{E019}\x{E01B}\x{E01B}\x{E01D}\x{E01D}\x{E01F}\x{E01F}\x{E021}\x{E021}\x{E023}\x{E023}\x{E025}\x{E025}\x{E027}\x{E027}\x{E029}\x{E029}\x{E02B}\x{E02B}\x{E02D}\x{E02D}\x{E02F}\x{E02F}\x{E031}\x{E031}\x{E033}\x{E033}\x{E035}\x{E035}\x{E037}\x{E037}\x{E039}\x{E039}\x{E03B}\x{E03B}\x{E03D}\x{E03D}\x{E03F}\x{E03F}\x{E041}\x{E041}\x{E043}\x{E043}\x{E045}\x{E045}\x{E047}\x{E047}\x{E049}\x{E049}\x{E04B}\x{E04B}\x{E04D}\x{E04D}\x{E04F}\x{E04F}/d;
				# &amp; , mittetähed , tõlkimine
				$ms_nos = teeMs_nosKuju($mTekstid);
				$insCmd .= "ms_att_OO = '${ms_att_OO}', 
							ms_lang = '${ms_lang}', 
							dic_code = '${DIC_DESC}', 
							vol_nr = ${vNr}, 
							ms = " . $dbh->quote($mTekstid) . " , 
							ms_nos = '${ms_nos}', 
							G = '${newGuid}'";
				$sth = $dbh->prepare($insCmd);
				$rcnt = $sth->execute();
				unless ($rcnt == 1) {
					$rsp_status_node->appendTextNode($sth->errstr . ' :: ' . $insCmd);
					$dbh->rollback;
					last;
				}
				if ($md) {
					$md .= ' :: ';
				}
				$md .= $mTekstid;
			} #foreach my $mElem
			
			if ($rcnt == 1) {
				$TA = $nowdtstr;
				$TA =~ s/T/ /g;

				$ms_att_OO = $uusO;
				$ms_att_OO =~ tr/\^0123456789_\%\+\/\|AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsŠšZzŽžTtUuVvWwÕõÄäÖöÜüXxYy/\x{E001}\x{E002}\x{E003}\x{E004}\x{E005}\x{E006}\x{E007}\x{E008}\x{E009}\x{E00A}\x{E00B}\x{E00C}\x{E00D}\x{E00E}\x{E00F}\x{E010}\x{E011}\x{E011}\x{E013}\x{E013}\x{E015}\x{E015}\x{E017}\x{E017}\x{E019}\x{E019}\x{E01B}\x{E01B}\x{E01D}\x{E01D}\x{E01F}\x{E01F}\x{E021}\x{E021}\x{E023}\x{E023}\x{E025}\x{E025}\x{E027}\x{E027}\x{E029}\x{E029}\x{E02B}\x{E02B}\x{E02D}\x{E02D}\x{E02F}\x{E02F}\x{E031}\x{E031}\x{E033}\x{E033}\x{E035}\x{E035}\x{E037}\x{E037}\x{E039}\x{E039}\x{E03B}\x{E03B}\x{E03D}\x{E03D}\x{E03F}\x{E03F}\x{E041}\x{E041}\x{E043}\x{E043}\x{E045}\x{E045}\x{E047}\x{E047}\x{E049}\x{E049}\x{E04B}\x{E04B}\x{E04D}\x{E04D}\x{E04F}\x{E04F}/d;
				my $uusXml = $uusA->toString;
				my $artKoopiaDom = XML::LibXML::Document->createDocument( "1.0", "UTF-8" );
				$artKoopiaDom->setDocumentElement($artKoopiaDom->importNode( $uusA->cloneNode(1) ));
				my $uusAKoopia = $artKoopiaDom->documentElement();
				foreach my $tekst ($uusAKoopia->findnodes(".//text()")) {
					my $juhhei = $tekst->toString;
					$juhhei = teeMs_nosKuju($juhhei);
					$tekst->setData($juhhei);
				}
				my $uusAltXml = $uusAKoopia->toString;
				my $insCmd = "INSERT INTO ${DIC_DESC} SET md = " . $dbh->quote($md) . ", ms_att_O = '${uusO}', ms_att_OO = '${ms_att_OO}', K = '${usrName}', KA = '${TA}', T = '${usrName}', TA = '${TA}', art = " . $dbh->quote($uusXml) . ", art_alt = " . $dbh->quote($uusAltXml) . ", vol_nr = ${vNr}, G = '${newGuid}'";
				$sth = $dbh->prepare($insCmd);
				$rcnt = $sth->execute();
				if ($rcnt == 1) {
					$dbh->commit;
					$nStatus = 4;
				}
				else {
					$rsp_status_node->appendTextNode($sth->errstr . ' :: ' . $insCmd);
					$dbh->rollback;
				}
			} #if ($rcnt == 1) {
		} #if ($qryMethod eq 'MySql') {
		else {
			# XML-i tuleb salvestada paralleelselt MySql-iga ...
			# aga XML puhul on veel unikaalsus kindlaks tegemata
			# unikaalseks jäävad ainult esimesed märksõnad artiklis
			$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/sr/xsl:apply-templates")->get_node(1);
			$xslnode->setAttribute("select", "${DICPR}:A[${fdArt}/\@${DICPR}:O[al_p:srch(.) > 0]]");
			$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/l/t/xsl:for-each")->get_node(1);
			$xslnode->setAttribute("select", 'self::node()');
			my $ss = $xslt->parse_stylesheet($queryXSL);
			$qryDOM = $ss->transform($dicDOM, vf => "'${dicVol}'");
			my $notUniqueNodesCnt = $qryDOM->documentElement()->childNodes->size();
			if ($notUniqueNodesCnt == 0) {
				$nStatus = 4;
			}
			else {
trahhAdd:
				$rsp_status_node->appendTextNode($lcDom->documentElement()->findvalue("itm[\@n = 'HW_HOM_COMBINATION'][\@l = '${APP_LANG}']") . " (${fSrchPtrn}) (${cmdId})!");
			}
		}
		#'dic_code' tabelis on 'ms_att_O' unikaalne, XML failis on 'O' unikaalne
		if ($nStatus == 4) {
			$dicDOM->documentElement()->appendChild($dicDOM->importNode($uusA));
			my $ss = $xslt->parse_stylesheet($sortXSL);
			$dicDOM = $ss->transform($dicDOM);
			if ($dicDOM->toFile($backupFile, 0)) {
# Win32 all on iga thread omaette protsess, seepärast lock vabastada LibXML-le, muidu ei pääse ligi
				if ($^O eq 'MSWin32') {
					flock($fh, LOCK_UN);
				}
				if ($dicDOM->toFile($xmlFile, 0)) {
					$nStatus = 5;
				}
				else {
					$rsp_status_node->appendTextNode("Server error writing '${xmlFile}' file (${cmdId})! See admin!");
				}
			}
			else {
				$rsp_status_node->appendTextNode("Server error writing backup '${backupFile}' file (${cmdId})! Try again!");
			}
		} #if ($nStatus == 4) {
	} #if ($nStatus == 3) {

	#nüüd võib lõpetada. Kõik on salvestatud
	my $leide;
	if ($nStatus == 5) {
		if ($art_xpath) { #homonüümsed
			if ($qryMethod eq 'MySql') {
				$sth = $dbh->prepare($sql);
				$sth->execute();

				my $respStr = '<sr>';
				$artsCount = -1;
				$leide = $sth->rows;
				unless ($leide > $MAX_PRINT_ARTS) {
					$respStr .= teeXMLStr($sth, '');
				}
				$respStr .= "</sr>";
				$qryDOM = $dicparser->parse_string($respStr);
			}
			else {
				# art_xpath - "homonüümsete kontroll":  DICPR & ":A[" & elm_xpath & "]"
				# elm_xpath - "arttingimus": m[ sOrgMarkSona (or sMarkSona)]
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/sr/xsl:apply-templates")->get_node(1);
				$xslnode->setAttribute("select", $art_xpath);
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/l/t/xsl:for-each")->get_node(1);
				$xslnode->setAttribute("select", $elm_xpath);
				my $ss = $xslt->parse_stylesheet($queryXSL);
				$qryDOM = $ss->transform($dicDOM, vf => "'${dicVol}'");
				$artsCount = $qryDOM->documentElement()->childNodes->size();
				$leide = $qryDOM->documentElement()->findnodes("A/l/t/span[\@class = '_b'][\@nr]")->size();
			}
		}
		else {
			$artsCount = 1;
		}
	}

	if ($nStatus > 1) {
		flock($fh, LOCK_UN);
		close($fh);
	}

	$rsp_vol_node->appendTextNode($dicVol);
	if ($nStatus == 5) {

		$rsp_count_node->appendTextNode($artsCount);
		$rsp_status_node->appendTextNode("Success");

		if ($artsCount == 1) {
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($uusA));
		}
		else {
			# $outDOM->documentElement()->setAttribute("qfID", $queryFileID);
			$outDOM->documentElement()->setAttribute("qinfo", $lcDom->documentElement()->findvalue("itm[\@n = 'CHECK_HOMS'][\@l = '${APP_LANG}']") . ": '${opMs}'");
			$outDOM->documentElement()->setAttribute("leide", $leide);
			$outDOM->documentElement()->appendChild($outDOM->importNode($qryDOM->documentElement()));
			my $brInfoDom = $dicparser->parse_string($browseInfoStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($brInfoDom->documentElement()));
			# $outDOM->toFile("temp/${queryFileID}.xml", 0);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($outDOM->documentElement()));
		}
	}
	else {
		$rsp_count_node->appendTextNode('0');
	}

# - lõpetamine
	if ($qryMethod eq 'MySql') {
		$dbh->disconnect();
	}

}
elsif (($cmdId eq "ClientDelete") && $nEditAllowed) {

	my ($dbh, $sth);
	my $vanaA;
	my ($fh, $destFh, $xmlFile, $xmlBackupFile, $destFile, $destBackupFile, $destDOM);

# - algus
	if ($qryMethod eq 'MySql') {
		$dbh = DBI->connect("DBI:mysql:database=${mySqlDbName};mysql_enable_utf8=1;host=192.168.11.11",
							 "eelex", "EELex",
							 {'RaiseError' => 0, AutoCommit => 1});
		$sth = $dbh->prepare("SELECT ${DIC_DESC}.art AS art FROM ${DIC_DESC} WHERE ${DIC_DESC}.G = '${artG}'");
		$sth->execute();
		my $artCnt = $sth->rows;
		if ($artCnt == 1) {
			if (my $ref = $sth->fetchrow_hashref()) {
				$vanaA = $dicparser->parse_string(decode_utf8($ref->{'art'}))->documentElement();
				$nStatus = 1;
			}
		}
		else {
			$rsp_status_node->appendTextNode("Failed on select ... where G = '${artG}' (${artCnt} tk) (${cmdId})!");
		}
		$sth->finish();
	}
	else {
		$nStatus = 1;
	}

	if ($nStatus == 1) {

		$xmlFile = "__sr/${DIC_DESC}/${dicVol}.xml";
		$xmlBackupFile = "backup/${dicVol}.xml";
		if (open($fh, '+<:utf8', $xmlFile)) {
			if (flock($fh, $lockType)) {
				$dicDOM = $dicparser->parse_file($xmlFile);
				my $nodes = $dicDOM->documentElement()->findnodes("${DICPR}:A[${DICPR}:G = '${artG}']");
				if ($nodes->size() == 1) {
					$vanaA = $nodes->get_node(1);
					$destFile = "__sr/${DIC_DESC}/${destVol}.xml";
					$destBackupFile = "backup/${destVol}.xml";
					if (open($destFh, '+<:utf8', $destFile)) {
						if (flock($destFh, $lockType)) {
							$destDOM = $dicparser->parse_file($destFile);
							$nStatus = 2;
						}
						else {
							$rsp_status_node->appendTextNode("Failed to flock '${destFile}' (${cmdId})!");
						}
					}
					else {
						$rsp_status_node->appendTextNode("Failed to open '${destFile}' (${cmdId})!");
					}
				}
				else {
					$rsp_status_node->appendTextNode("Failed on 'findnodes(G = ${artG})' (" . $nodes->size() . " tk) (${cmdId})!");
				}
			}
			else {
				$rsp_status_node->appendTextNode("Failed to flock '${xmlFile}' (${cmdId})!");
			}
		}
		else {
			$rsp_status_node->appendTextNode("Failed to open '${xmlFile}' (${cmdId})!");
		}
	}
	
	#vanaA on nüüd käes
	my ($vanaT, $vanaTA, $vanaO);
	if ($nStatus == 2) {

		$vanaT = $vanaA->findvalue("${DICPR}:T");
		$vanaTA = $vanaA->findvalue("${DICPR}:TA");
		$vanaO = $vanaA->findvalue("${fdArt}/\@${DICPR}:O");

		$nStatus = 3;
	}
	
	my $dvNr = substr($destVol, 3, 1);

	#võib nüüd salvestada - kui vaja
	if ($nStatus == 3) {

		my $m1Elem = $vanaA->findnodes("${fdArt}")->get_node(1);
		$opMs = $m1Elem->textContent;
		foreach my $attNode ($m1Elem->attributes()) {
			if ($attNode->localname ne 'O') {
				$opAttrs .= " \@" . $attNode->nodeName . "='" . $attNode->textContent . "'";
			}
		}
		$opAttrs = substr($opAttrs, 1);

		my $refNode;
		my $xNode = $vanaA->findnodes("${DICPR}:X")->get_node(1);
		unless ($xNode) {
			$refNode = $vanaA->findnodes("${DICPR}:XA")->get_node(1);
			$xNode = $vanaA->insertBefore($prmDOM->createElement("${DICPR}:X"), $refNode);
			$xNode->appendTextNode('-');
		}
		$xNode->firstChild->setData($usrName);
		my $xaNode = $vanaA->findnodes("${DICPR}:XA")->get_node(1);
		unless ($xaNode) {
			# alati viimane element skeemis ...
			$xaNode = $vanaA->appendChild($prmDOM->createElement("${DICPR}:XA"));
			$xaNode->appendTextNode('-');
		}
		$xaNode->firstChild->setData($nowdtstr);
		$vanaA->setAttributeNS($DICURI, 'KF', $dicVol);

		if ($qryMethod eq 'MySql') {
			my ($rcnt, $TA);
			$dbh->begin_work;
			my $updCmd = "UPDATE msid SET vol_nr = ${dvNr} WHERE dic_code = '${DIC_DESC}' AND G = '${artG}'";
			$sth = $dbh->prepare($updCmd);
			$rcnt = $sth->execute();
			if ($rcnt > 0) {
				$TA = $nowdtstr;
				$TA =~ s/T/ /g;

				# et MySql - i ikka korrenktne XML salvestuks
				$vanaA->setNamespace($DICURI, $DICPR, 0);
				my $vanaXml = $vanaA->toString;

				my $artKoopiaDom = XML::LibXML::Document->createDocument( "1.0", "UTF-8" );
				$artKoopiaDom->setDocumentElement($artKoopiaDom->importNode( $vanaA->cloneNode(1) ));
				my $vanaAKoopia = $artKoopiaDom->documentElement();
				foreach my $tekst ($vanaAKoopia->findnodes(".//text()")) {
					my $juhhei = $tekst->toString;
					# &amp; , muutujad + mittetähed , tõlkimine
					$juhhei = teeMs_nosKuju($juhhei);
					$tekst->setData($juhhei);
				}
				my $vanaAltXml = $vanaAKoopia->toString;

				$updCmd = "UPDATE ${DIC_DESC} SET vol_nr = ${dvNr}, X = '${usrName}', XA = '${TA}', art = " . $dbh->quote($vanaXml) . ", art_alt = " . $dbh->quote($vanaAltXml) . " WHERE ${DIC_DESC}.G = '${artG}'";
				
				$sth = $dbh->prepare($updCmd);
				$rcnt = $sth->execute();
				if ($rcnt == 1) {
					$dbh->commit;
					$nStatus = 4;
				}
				else {
					$rsp_status_node->appendTextNode($sth->errstr . ' :: ' . $updCmd);
					$dbh->rollback;
				}
			}
			else {
				$rsp_status_node->appendTextNode($sth->errstr . ' :: ' . $updCmd);
				$dbh->rollback;
			}
		}
		else {
			# XML-i tuleb salvestada paralleelselt MySql-iga ...
			$nStatus = 4;
		}
		if ($nStatus == 4) {
			$destDOM->documentElement()->appendChild($vanaA);
			my $ss = $xslt->parse_stylesheet($sortXSL);
			$destDOM = $ss->transform($destDOM);
			if ($dicDOM->toFile($xmlBackupFile, 0) && $destDOM->toFile($destBackupFile, 0)) {
# Win32 all on iga thread omaette protsess, seepärast lock vabastada LibXML-le, muidu ei pääse ligi
				if ($^O eq 'MSWin32') {
					flock($fh, LOCK_UN);
					flock($destFh, LOCK_UN);
				}
				if ($dicDOM->toFile($xmlFile, 0)) {
					if ($destDOM->toFile($destFile, 0)) {
						$nStatus = 5;
					}
					else {
						$rsp_status_node->appendTextNode("Server error writing '${destFile}' file (${cmdId})! See admin!");
					}
				}
				else {
					$rsp_status_node->appendTextNode("Server error writing '${xmlFile}' file (${cmdId})! See admin!");
				}
			}
			else {
				$rsp_status_node->firstChild->setData("Server error writing backup files (${cmdId})! Try again!");
			}
		}
	}

	#nüüd võib lõpetada. Kõik on salvestatud
	my $leide;
	if ($nStatus == 5) {
		if ($art_xpath) { #homonüümsed
			if ($qryMethod eq 'MySql') {
				$sth = $dbh->prepare($sql);
				$sth->execute();

				my $respStr = '<sr>';
				$artsCount = -1;
				$leide = $sth->rows;
				unless ($leide > $MAX_PRINT_ARTS) {
					$respStr .= teeXMLStr($sth, '');
				}
				$respStr .= "</sr>";
				$qryDOM = $dicparser->parse_string($respStr);
			}
			else {
				# art_xpath - "homonüümsete kontroll":  DICPR & ":A[" & elm_xpath & "]"
				# elm_xpath - "arttingimus": m[ sOrgMarkSona (or sMarkSona)]
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/sr/xsl:apply-templates")->get_node(1);
				$xslnode->setAttribute("select", $art_xpath);
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/l/t/xsl:for-each")->get_node(1);
				$xslnode->setAttribute("select", $elm_xpath);
				my $ss = $xslt->parse_stylesheet($queryXSL);
				$qryDOM = $ss->transform($dicDOM, vf => "'${dicVol}'");
				$artsCount = $qryDOM->documentElement()->childNodes->size();
				$leide = $qryDOM->documentElement()->findnodes("A/l/t/span[\@class = '_b'][\@nr]")->size();
			}
		}
		else {
			$artsCount = 0; # kustutamise korral, "midagi ei jäänud alles"
		}
	}

	if ($nStatus > 1) {
		flock($fh, LOCK_UN);
		close($fh);
		flock($destFh, LOCK_UN);
		close($destFh);
	}

	$rsp_vol_node->appendTextNode($dicVol);
	if ($nStatus == 5) {

		$rsp_count_node->appendTextNode($artsCount);
		$rsp_status_node->appendTextNode("Success");

		if ($artsCount > 0) {
			# $outDOM->documentElement()->setAttribute("qfID", $queryFileID);
			$outDOM->documentElement()->setAttribute("qinfo", $lcDom->documentElement()->findvalue("itm[\@n = 'CHECK_HOMS'][\@l = '${APP_LANG}']") . ": '${opMs}'");
			$outDOM->documentElement()->setAttribute("leide", $leide);
			$outDOM->documentElement()->appendChild($outDOM->importNode($qryDOM->documentElement()));
			my $brInfoDom = $dicparser->parse_string($browseInfoStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($brInfoDom->documentElement()));
			# $outDOM->toFile("temp/${queryFileID}.xml", 0);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($outDOM->documentElement()));
		}
	}
	else {
		$rsp_count_node->appendTextNode('-1');
	}

# - lõpetamine
	if ($qryMethod eq 'MySql') {
		$dbh->disconnect();
	}
}
elsif (($cmdId eq "ClientRestore") && $nEditAllowed) {

	my ($dbh, $sth);
	my $vanaA;
	my ($fh, $destFh, $xmlFile, $xmlBackupFile, $destFile, $destBackupFile, $destDOM);

# - algus
	if ($qryMethod eq 'MySql') {
		$dbh = DBI->connect("DBI:mysql:database=${mySqlDbName};mysql_enable_utf8=1;host=192.168.11.11",
							 "eelex", "EELex",
							 {'RaiseError' => 0, AutoCommit => 1});
		$sth = $dbh->prepare("SELECT ${DIC_DESC}.art AS art FROM ${DIC_DESC} WHERE ${DIC_DESC}.G = '${artG}'");
		$sth->execute();
		my $artCnt = $sth->rows;
		if ($artCnt == 1) {
			if (my $ref = $sth->fetchrow_hashref()) {
				$vanaA = $dicparser->parse_string($ref->{'art'})->documentElement();
				$nStatus = 1;
			}
		}
		else {
			$rsp_status_node->appendTextNode("Failed on select ... where G = '${artG}' (${artCnt} tk) (${cmdId})!");
		}
		$sth->finish();
	}
	else {
		$nStatus = 1;
	}
	
	if ($nStatus == 1) {

		$xmlFile = "__sr/${DIC_DESC}/${dicVol}.xml";
		$xmlBackupFile = "backup/${dicVol}.xml";
		if (open($fh, '+<:utf8', $xmlFile)) {
			if (flock($fh, $lockType)) {
				$dicDOM = $dicparser->parse_file($xmlFile);
				my $nodes = $dicDOM->documentElement()->findnodes("${DICPR}:A[${DICPR}:G = '${artG}']");
				if ($nodes->size() == 1) {
					$vanaA = $nodes->get_node(1);
					$destFile = "__sr/${DIC_DESC}/${destVol}.xml";
					$destBackupFile = "backup/${destVol}.xml";
					if (open($destFh, '+<:utf8', $destFile)) {
						if (flock($destFh, $lockType)) {
							$destDOM = $dicparser->parse_file($destFile);
							$nStatus = 2;
						}
						else {
							$rsp_status_node->appendTextNode("Failed to flock '${destFile}' (${cmdId})!");
						}
					}
					else {
						$rsp_status_node->appendTextNode("Failed to open '${destFile}' (${cmdId})!");
					}
				}
				else {
					$rsp_status_node->appendTextNode("Failed on 'findnodes(G = ${artG})' (" . $nodes->size() . " tk) (${cmdId})!");
				}
			}
			else {
				$rsp_status_node->appendTextNode("Failed to flock '${xmlFile}' (${cmdId})!");
			}
		}
		else {
			$rsp_status_node->appendTextNode("Failed to open '${xmlFile}' (${cmdId})!");
		}
	}
	
	#vanaA on nüüd käes
	my ($vanaT, $vanaTA, $vanaO);
	if ($nStatus == 2) {

		$vanaT = $vanaA->findvalue("${DICPR}:T");
		$vanaTA = $vanaA->findvalue("${DICPR}:TA");
		$vanaO = $vanaA->findvalue("${fdArt}/\@${DICPR}:O");

		$nStatus = 3;
	}

	my $vNr = substr($dicVol, 3, 1);
	my $dvNr = substr($destVol, 3, 1);

	#võib nüüd salvestada - kui vaja
	if ($nStatus == 3) {

		my $m1Elem = $vanaA->findnodes("${fdArt}")->get_node(1);
		$opMs = $m1Elem->textContent;
		foreach my $attNode ($m1Elem->attributes()) {
			if ($attNode->localname ne 'O') {
				$opAttrs .= " \@" . $attNode->nodeName . "='" . $attNode->textContent . "'";
			}
		}
		$opAttrs = substr($opAttrs, 1);

		if ($qryMethod eq 'MySql') {
			my ($rcnt, $TA);
			$dbh->begin_work;
			my $updCmd = "UPDATE msid SET vol_nr = ${dvNr} WHERE dic_code = '${DIC_DESC}' AND G = '${artG}'";
			$sth = $dbh->prepare($updCmd);
			$rcnt = $sth->execute();
			if ($rcnt > 0) {
				$updCmd = "UPDATE ${DIC_DESC} SET vol_nr = ${dvNr} WHERE ${DIC_DESC}.G = '${artG}'";
				$sth = $dbh->prepare($updCmd);
				$rcnt = $sth->execute();
				if ($rcnt == 1) {
					$dbh->commit;
					$nStatus = 4;
				}
				else {
					$rsp_status_node->appendTextNode($sth->errstr . ' :: ' . $updCmd);
					$dbh->rollback;
				}
			}
			else {
				$rsp_status_node->appendTextNode($sth->errstr . ' :: ' . $updCmd);
				$dbh->rollback;
			}
		}
		else {
			# XML-i tuleb salvestada paralleelselt MySql-iga ...
			$nStatus = 4;
		}
		if ($nStatus == 4) {
			$destDOM->documentElement()->appendChild($vanaA);
			my $ss = $xslt->parse_stylesheet($sortXSL);
			$destDOM = $ss->transform($destDOM);
			if ($dicDOM->toFile($xmlBackupFile, 0) && $destDOM->toFile($destBackupFile, 0)) {
# Win32 all on iga thread omaette protsess, seepärast lock vabastada LibXML-le, muidu ei pääse ligi
				if ($^O eq 'MSWin32') {
					flock($fh, LOCK_UN);
					flock($destFh, LOCK_UN);
				}
				if ($dicDOM->toFile($xmlFile, 0)) {
					if ($destDOM->toFile($destFile, 0)) {
						$nStatus = 5;
					}
					else {
						$rsp_status_node->appendTextNode("Server error writing '${destFile}' file (${cmdId})! See admin!");
					}
				}
				else {
					$rsp_status_node->appendTextNode("Server error writing '${xmlFile}' file (${cmdId})! See admin!");
				}
			}
			else {
				$rsp_status_node->firstChild->setData("Server error writing backup files (${cmdId})! Try again!");
			}
		}
	}

	#nüüd võib lõpetada. Kõik on salvestatud
	my $leide;
	if ($nStatus == 5) {
		if ($art_xpath) { #homonüümsed
			if ($qryMethod eq 'MySql') {
				$sth = $dbh->prepare($sql);
				$sth->execute();

				my $respStr = '<sr>';
				$artsCount = -1;
				$leide = $sth->rows;
				unless ($leide > $MAX_PRINT_ARTS) {
					$respStr .= teeXMLStr($sth, '');
				}
				$respStr .= "</sr>";
				$qryDOM = $dicparser->parse_string($respStr);
			}
			else {
				# art_xpath - "homonüümsete kontroll":  DICPR & ":A[" & elm_xpath & "]"
				# elm_xpath - "arttingimus": m[ sOrgMarkSona (or sMarkSona)]
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/sr/xsl:apply-templates")->get_node(1);
				$xslnode->setAttribute("select", $art_xpath);
				$xslnode = $queryXSL->documentElement()->findnodes("xsl:template[\@match = 'al:A']/A/l/t/xsl:for-each")->get_node(1);
				$xslnode->setAttribute("select", $elm_xpath);
				my $ss = $xslt->parse_stylesheet($queryXSL);
				$qryDOM = $ss->transform($dicDOM, vf => "'${dicVol}'");
				$artsCount = $qryDOM->documentElement()->childNodes->size();
				$leide = $qryDOM->documentElement()->findnodes("A/l/t/span[\@class = '_b'][\@nr]")->size();
			}
		}
		else {
			$artsCount = 1; # taastamise korral, "vähemalt üks on"
		}
	}

	if ($nStatus > 1) {
		flock($fh, LOCK_UN);
		close($fh);
		flock($destFh, LOCK_UN);
		close($destFh);
	}

	$rsp_vol_node->appendTextNode($dicVol);
	if ($nStatus == 5) {

		$rsp_count_node->appendTextNode($artsCount);
		$rsp_status_node->appendTextNode("Success");

		if ($artsCount > 1) {
			# $outDOM->documentElement()->setAttribute("qfID", $queryFileID);
			$outDOM->documentElement()->setAttribute("qinfo", $lcDom->documentElement()->findvalue("itm[\@n = 'CHECK_HOMS'][\@l = '${APP_LANG}']") . ": '${opMs}'");
			$outDOM->documentElement()->setAttribute("leide", $leide);
			$outDOM->documentElement()->appendChild($outDOM->importNode($qryDOM->documentElement()));
			my $brInfoDom = $dicparser->parse_string($browseInfoStr);
			$outDOM->documentElement()->appendChild($outDOM->importNode($brInfoDom->documentElement()));
			# $outDOM->toFile("temp/${queryFileID}.xml", 0);
			$responseDOM->documentElement()->appendChild($responseDOM->importNode($outDOM->documentElement()));
		}
	}
	else {
		$rsp_count_node->appendTextNode('-1');
	}

# - lõpetamine
	if ($qryMethod eq 'MySql') {
		$dbh->disconnect();
	}
}
elsif ($cmdId eq "ImportRead") {
	my $impDicDesc = substr($dicVol, 0, 3);
	# ../__shs(_test)/__sr
	my $pathBase = $art_xpath;

	my $impShsConf = $dicparser->parse_file("shsconfig_${impDicDesc}.xml");
	my $impDicPr = $impShsConf->documentElement()->findvalue('dicpr');
	my $impDicUri = $impShsConf->documentElement()->findvalue('dicuri');

	my $xsldom = $dicparser->parse_file('xsl/import_i.xsl');

	$xsldom->documentElement()->setNamespace($impDicUri, 'al', 0); #sr jaoks
	$xsldom->documentElement()->setNamespace($impDicUri, $impDicPr, 0); #käivitatava päringu jaoks
	$xsldom->documentElement()->setNamespace($DICURI, $DICPR, 0); #väljastatavate elementide jaoks
	$xslnode = $xsldom->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/xsl:element/xsl:apply-templates[\@select='thisQuery']")->get_node(1);
	$xslnode->setAttribute("select", "${impDicPr}:A[${impDicPr}:G = '${artG}']");
	my $ss = $xslt->parse_stylesheet($xsldom);

	my $xmlFile = "${pathBase}/${impDicDesc}/${dicVol}.xml";

	if (open(XMLF, '<:utf8', $xmlFile)) {
		# if (flock(XMLF, $lockType)) {
			$dicDOM = $dicparser->parse_file($xmlFile);
			$qryDOM = $ss->transform($dicDOM, pr => "'${DICPR}'", uri => "'${DICURI}'", dic_desc => "'${impDicDesc}'");
			$artsCount = $qryDOM->documentElement()->childNodes->size();
			my $artikkel = $qryDOM->documentElement()->childNodes->get_node(1);

			$rsp_count_node->appendTextNode($artsCount);

			if ($artsCount == 1 && $artikkel->localname eq 'A') {
				$rsp_status_node->appendTextNode("Success");
#				$rsp_vol_node->appendTextNode($dicVol);
				$responseDOM->documentElement()->appendChild($responseDOM->importNode($artikkel));
			}
			else {
				$rsp_status_node->appendTextNode("Failed on 'findnodes(${xmlFile} - ${artG}) (${cmdId})!");
			}
			flock(XMLF, LOCK_UN);
		# }
		# else {
		#	$rsp_status_node->appendTextNode("Failed to flock '${xmlFile}' (${cmdId})!");
		# }
		close(XMLF);
	}
	else {
		$rsp_status_node->appendTextNode("Failed to open '${xmlFile}' (${cmdId})!");
	}
}
elsif ($cmdId eq "SaveList") {
	my $xsldom = $dicparser->parse_file('xsl/gethwdschunk.xsl');
	my $ss = $xslt->parse_stylesheet($xsldom);
	my $poss1 = 1;
	my $poss2 = 1000000;

	my $xmlFile = "temp/${art_xpath}.xml";
	if (open(XMLF, '<:utf8', $xmlFile)) {
		if (flock(XMLF, $lockType)) {
			$dicDOM = $dicparser->parse_file($xmlFile);
			$qryDOM = $ss->transform($dicDOM, pos1 => "'${poss1}'", pos2 => "'${poss2}'");
			flock(XMLF, LOCK_UN);
			$nStatus = 1;
		}
		close(XMLF);
	}
	if ($nStatus) {
		$artsCount = $qryDOM->documentElement()->childNodes->size();

		# ja cloneNode peab vist olema, muidu ei oska ta enam atribuuti kirjutada outDOM - le
		$outDOM->documentElement()->appendChild($outDOM->importNode($qryDOM->documentElement()));

		$rsp_status_node->appendTextNode("Success");
		$rsp_count_node->appendTextNode($artsCount);

		$responseDOM->documentElement()->appendChild($responseDOM->importNode($outDOM->documentElement()));
	}
	else {
		$rsp_status_node->appendTextNode("Failed to open/flock '${xmlFile}' (${cmdId})!");
	}
}
elsif (($cmdId eq "ClientPrint") && $nEditAllowed) {

    my $xsldom = $dicparser->parse_file('xsl/print.xsl');
	$xsldom->documentElement()->setNamespace($DICURI, 'al', 0);
	$xsldom->documentElement()->setNamespace($DICURI, $DICPR, 0);

	$xslnode = $xsldom->documentElement()->findnodes("xsl:variable[\@name = 'qryMode']")->get_node(1);
	$xslnode->appendTextNode($elm_xpath);

	if ($elm_xpath eq 'useM') {
		if ($dicVol eq "${DIC_DESC}All") {
			exit;
		}
		$xslnode = $xsldom->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/xsl:copy/xsl:choose/xsl:when/xsl:variable/xsl:for-each")->get_node(1);
		$xslnode->setAttribute("select", $art_xpath);
	}
	else {
		$xslnode = $xsldom->documentElement()->findnodes("xsl:template[\@match = 'al:sr']/xsl:copy/xsl:choose/xsl:otherwise/xsl:apply-templates")->get_node(1);
		$xslnode->setAttribute("select", $art_xpath);
	}

	my $ss = $xslt->parse_stylesheet($xsldom);

	my $qrycount = 0;

	my $xmlFile;
	
	if ($dicVol eq "${DIC_DESC}All") {
		$i = 1;
		$j = $DIC_VOLS_COUNT;
	}
	else {
		$i = substr($dicVol, 3, 1);
		$j = $i;
	}
	
	for ($i; $i <= $j; $i++) {
	
		$xmlFile = "__sr/${DIC_DESC}/${DIC_DESC}${i}.xml";

		if (open(XMLF, '<:utf8', $xmlFile)) {
			if (flock(XMLF, $lockType)) {
				$dicDOM = $dicparser->parse_file($xmlFile);
				$qryDOM = $ss->transform($dicDOM);
				flock(XMLF, LOCK_UN);
				$nStatus = 1;
			}
			close(XMLF);
		}
		if ($nStatus) {
			$artsCount = $qryDOM->documentElement()->childNodes->size();
			$qrycount += $artsCount;

			if ($qrycount > $MAX_PRINT_ARTS) {
				last;
			}

			unless (defined($printDOM)) {
				$printDOM = XML::LibXML::Document->createDocument( "1.0", "UTF-8" );
				$printDOM->setDocumentElement($printDOM->importNode( $qryDOM->documentElement()->cloneNode(0) ));
			}

			if ($artsCount > 0) {
				for ($k = 1; $k <= $artsCount; $k++) {
					$printDOM->documentElement()->appendChild($printDOM->importNode( $qryDOM->documentElement()->childNodes->get_node($k) ));
				}
#				my $printNodes = $printDOM->documentElement()->findnodes("*");
#				my $newNodes = $qryDOM->documentElement()->findnodes("*");
#				$printNodes->append($newNodes);
			}
		}
		else {
			last;
		}
	}
	
	if ($nStatus) {

		$rsp_count_node->appendTextNode($qrycount);

		if ($qrycount > $MAX_PRINT_ARTS) {
			$rsp_status_node->appendTextNode("ClientPrint_TOOMANY");
		}
		else {
			$rsp_status_node->appendTextNode("Success");
			$rsp_vol_node->appendTextNode($dicVol);
#			$responseDOM->documentElement()->appendChild($printDOM->documentElement());
#			$responseDOM->toFile("temp/printResponseDOM_${usrName}.xml", 0);
			$printDOM->toFile("temp/printDOM_${usrUnName}.xml", 0);
		}
	}
	else {
		$rsp_status_node->appendTextNode("Failed to open/flock '${xmlFile}' (${cmdId})!");
	}

}

$nowdtstr =~ s/T/\t/g;
my $elTime = (time() - $startTime);
my $logSta = $rsp_status_node->firstChild->toString(0);
unless ($rsp_count_node->firstChild) {
	$rsp_count_node->appendTextNode('-1');
}
my $logCnt = $rsp_count_node->firstChild->toString(0);

$sqlCmd =~ s/\s+/ /g;

use Tie::File;
my @logLines;
tie(@logLines, 'Tie::File', "logs/${DIC_DESC}/${logFileName}.log");

### Kui siin midagi muudad, siis sama teha ka 'tools.cgi' - s !
my $logLine = "${nowdtstr}\t${usrName}\t\"${remoteAddress}\"\t${cmdId}\t${dicVol}\t${elTime}s.\t${logSta}\t${logCnt}\t${qinfo}\t${art_xpath}\tsrchPtrn: '${fSrchPtrn}'\t${artMuudatused}\t${opMs}\t${opAttrs}\t${qryMethod}\t${sqlCmd}";

unshift(@logLines, encode_utf8($logLine));
untie(@logLines);

print "Content-type: text/xml; charset=utf-8\n\n";
print $responseDOM->toString(0);

