<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:al="http://www.eo.ee/xml/xsl/scripts" xmlns:pref="http://www.eki.ee/dict/fon" xmlns:t="http://www.eki.ee/dict/fon" version="1.0">
	<xsl:output method="html" omit-xml-declaration="yes" indent="no" encoding="utf-8"/>
	<msxsl:script language="JScript" implements-prefix="al">

    var tagaTyhik = '';
    // &lt;!--m&#xE4;rks&#xF5;na m korral tagab = 1 t&#xFC;hiku mittepanemise--&gt;
    var kyljes = 1;
    var currentLn = '';
    
    function paneKylge(sym) {
      kyljes = 1;
      return sym;
    }
    
    function paneTyhikJarele(sym) {
      tagaTyhik = ' ';
      return sym;
    }
    
    function paneTyhikEtte(myNodeList, ln) {
      var prevNode;
      var retStr;
      if (tagaTyhik == ' ')
        retStr = '';
      else {
        if (kyljes == 0) {
          if (ln == currentLn)                                            // omab t&#xE4;hendust ainult elemendi ja tema atribuutide vaheldumisel
            retStr = ' ';
          else {                                                          // algas uus element, atribuudi korral saadetakse ka element ise, mitte atribuut
            var tekst = myNodeList[0].text;
            if (");:,.!?-".indexOf(tekst.substr(0, 1)) &gt; -1)                      // jooksev
                if (tekst.substr(1, 1) == ' ')
                  retStr = '';
                else
                  retStr = ' ';
            else {
              prevNode = myNodeList[0].selectSingleNode("preceding-sibling::node()[1]");
              if (prevNode == null)
                // k&#xF5;ik on ju tekstid, sellep&#xE4;rast 'parentNode'
                prevNode = myNodeList[0].parentNode.selectSingleNode("preceding-sibling::node()[1]");
              if (prevNode == null)
                retStr = ' ';
              else {
                if ("(-".indexOf(prevNode.text.substr(prevNode.text.length - 1, 1)) &gt; -1)
                  retStr = '';
                else
                  retStr = ' ';
              }
            }
          }
        }
        else
          retStr = '';
      }
//      retStr = currentLn + '- &gt;' + ln + ':' + myNodeList[0].nodeName + ':' + retStr;
      currentLn = ln;
      return retStr;
    }



    function capitalize(tekst) {
      return tekst.substr(0, 1).toUpperCase() + tekst.substr(1);
    }

    function unNameXsl(inpStr) {
        var unStr = '', i;
        // unStr = inpStr.replace(/:/, "-");
        for (i = 0; i &lt; inpStr.length; i++) {
            unStr += '_' + inpStr.charCodeAt(i);
        }
        return unStr;
    }

	function RS(currtext, itStyle, locName, printing) {
	var nt;
  
	if (typeof(currtext) == 'object') { // nodelist
		if (currtext.length == 0) {
			return '';
		}
		nt = currtext[0].text;
	}
	else {
		nt = currtext;
	}

	var ss;
	if (typeof(itStyle) == 'object') { // nodelist
		ss = itStyle[0].text;
	}
	else {
		ss = itStyle;
	}

	var ln;
	if (typeof(locName) == 'object') { // nodelist
		ln = locName[0].text;
	}
	else {
		ln = locName;
	}

	var print;
	if (typeof(printing) == 'object') {
		print = printing[0].text;
	}
	else {
		print = printing;
	}

    if (ln == 'm')
        nt = nt.replace(/_+$/, ''); // alakriipsud m jt l&#xF5;pust maha
    
    //Jutum&#xE4;rgid nagu raamatus: &lt;&lt;  &gt;&gt; (l&#xF5;petaval on ees konks)
		//nt = nt.replace(/\^"/g, String.fromCharCode(0x00BB));
		//nt = nt.replace(/"/g, String.fromCharCode(0x00AB));
		nt = nt.replace(/\^"/g, '\u201D');
		nt = nt.replace(/"/g, '\u201E');
    

    // $1-$9, $1 on esimene
		nt = nt.replace(/(&amp;suba;(.+?)&amp;subl;)/g, "$2".sub());
		nt = nt.replace(/(&amp;supa;(.+?)&amp;supl;)/g, "$2".sup());
		nt = nt.replace(/(&amp;ba;(.+?)&amp;bl;)/g, "$2".bold());
		nt = nt.replace(/(&amp;la;(.+?)&amp;ll;)/g, "&lt;u&gt;$2&lt;/u&gt;");

		if (ss == '1') { //kursiivis p&#xF6;&#xF6;rata kursiiv tagasi
			nt = nt.replace(/(&amp;ema;(.+?)&amp;eml;)/g, "&lt;i style='font-style: normal;'&gt;$2&lt;/i&gt;");
		}
		else {
			nt = nt.replace(/(&amp;ema;(.+?)&amp;eml;)/g, "$2".italics());
		}

		// muutujad (entities)
		// nt = nt.replace(/(&amp;(\w+?);)/g, "$2".italics());
		nt = nt.replace(/(&amp;(ja|jne|jt|ka|ehk|Hrl|hrl|nt|puudub|v|vm|vms|&#x43D;&#x430;&#x43F;&#x440;\.|&#x438; &#x434;&#x440;\.|&#x438; &#x442;\. &#x43F;\.|&#x433;\.);)/g, "$2".italics());

        // 0x1D100 - 0x1D126
/*        var muss = '';
        for(i=0xDD00; i&lt;=0xDD26; i++) {
            muss += String.fromCharCode(0xD834, i);
        }
        var re = new RegExp("\(\[" + muss + "\]\)", 'g');
		nt = nt.replace(re, "&lt;span style='font-family:symbola;font-size:x-large'&gt;$1&lt;/span&gt;");
*/

		nt = nt.replace(/&amp;gclef;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D11E;&lt;/span&gt;");
		nt = nt.replace(/&amp;gclefottavaalta;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D11F;&lt;/span&gt;");
		nt = nt.replace(/&amp;gclefottavabassa;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D120;&lt;/span&gt;");
		nt = nt.replace(/&amp;cclef;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D121;&lt;/span&gt;");
		nt = nt.replace(/&amp;fclef;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D122;&lt;/span&gt;");
		nt = nt.replace(/&amp;fclefottavaalta;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D123;&lt;/span&gt;");
		nt = nt.replace(/&amp;fclefottavabassa;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D124;&lt;/span&gt;");
		nt = nt.replace(/&amp;drumclef1;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D125;&lt;/span&gt;");
		nt = nt.replace(/&amp;drumclef2;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D126;&lt;/span&gt;");

		nt = nt.replace(/&amp;fermata;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D110;&lt;/span&gt;");
		nt = nt.replace(/&amp;segno;/g, "&lt;span style='font-family:symbola;font-size:x-large'&gt;&amp;#x1D10B;&lt;/span&gt;");


    tagaTyhik = '';
    kyljes = 0;
    
		return nt;
		}

        </msxsl:script>
	<xsl:variable name="pildiJuurikas">../__sr/</xsl:variable>
	<xsl:variable name="dic_desc">fon</xsl:variable>
	<xsl:variable name="itad">;etvw_mrk;</xsl:variable>
	<xsl:variable name="edMode">0</xsl:variable>
	<xsl:variable name="printing">0</xsl:variable>
	<xsl:variable name="showShaded">1</xsl:variable>
	<xsl:template match="/">
		<xsl:apply-templates select="*"/>
	</xsl:template>
	<xsl:template match="pref:sr">
		<xsl:variable name="srLang">
			<xsl:choose>
				<xsl:when test="@xml:lang">
					<xsl:value-of select="@xml:lang"/>
				</xsl:when>
				<xsl:otherwise>et</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<body lang="{$srLang}">
			<xsl:if test="$showShaded = '1' and $printing = '1'">
				<xsl:text/>
				<div>
					<h3 style="background-color: silver;">
						<xsl:value-of select="@qinfo"/>
					</h3>
				</div>
			</xsl:if>
			<xsl:apply-templates select="*">
				<xsl:with-param name="rada"/>
			</xsl:apply-templates>
		</body>
	</xsl:template>
	<!--           <xsl:template match="pref:A">
                <xsl:param name="rada">
                </xsl:param>
                <xsl:variable name="posnr">
                    <xsl:number level="single" format="1">
                    </xsl:number>
                </xsl:variable>
                <p>
                    <xsl:apply-templates select="*">
                        <xsl:with-param name="rada">
                            <xsl:value-of select="concat($rada, name(), '[', $posnr, ']/')" />
                        </xsl:with-param>
                    </xsl:apply-templates>
                </p>
            </xsl:template>-->
	<xsl:template match="*">
		<xsl:param name="rada"/>
		<xsl:variable name="shouldIShow">
			<xsl:choose>
				<xsl:when test="(self::t:sr) or (self::t:A) or (self::t:kp) or (self::t:terg)">1</xsl:when>
				<xsl:when test="(self::t:ter) or (self::t:pf) or (self::t:pn) or (self::t:mrk)">1</xsl:when>
				<xsl:when test="(self::t:d) or (self::t:KOM) or (self::t:komg) or (self::t:kom)">1</xsl:when>
				<xsl:when test="(self::t:kaut) or (self::t:kaeg) or (self::t:plt)">1</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$shouldIShow = '1'">
			<xsl:variable name="inPrint">
				<xsl:choose>
					<xsl:when test="1 = 2"/>
					<xsl:when test="self::t:KOM">0</xsl:when>
					<xsl:otherwise>1</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:if test="not($inPrint = '0' and $showShaded = '0')">
				<xsl:variable name="posnr">
					<xsl:number level="single" format="1"/>
				</xsl:variable>
				<!-- enne elemendi teksti -->
				<xsl:if test="self::pref:A">
					<xsl:value-of select="concat('&lt;', 'p', '&gt;')" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:if test="self::t:kp and preceding-sibling::*">
					<br/>
				</xsl:if>
				<xsl:if test="self::t:KOM">
					<br/>
				</xsl:if>
				<xsl:if test="self::t:kom and not(preceding-sibling::node()[1][name() = 't:kom'])">
					<xsl:value-of select="al:paneKylge('&lt;font color=&quot;blue&quot;&gt; &amp;lt;!--&lt;/font&gt;')" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:if test="self::t:KOM">
					<xsl:value-of select="concat('&lt;', 'span class=&quot;etvw_t_KOM_75_79_77&quot;', '&gt;')" disable-output-escaping="yes"/>
				</xsl:if>
				<!-- võimalik elemendi tekst -->
				<xsl:choose>
					<xsl:when test="1 = 2"/>
					<xsl:when test="@pref:mT = 'img'">
						<xsl:element name="div">
							<xsl:element name="img">
								<xsl:attribute name="src">
									<xsl:value-of select="concat($pildiJuurikas, $dic_desc, '/__video/', .)"/>
								</xsl:attribute>
								<xsl:attribute name="alt">
									<xsl:value-of select="."/>
								</xsl:attribute>
								<xsl:attribute name="title">
									<xsl:value-of select="concat('&lt;', ., '&gt;')"/>
								</xsl:attribute>
								<xsl:if test="@pref:mW">
									<xsl:attribute name="style">width:<xsl:value-of select="@pref:mW"/>;</xsl:attribute>
								</xsl:if>
							</xsl:element>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="node()[not(. = '')]">
							<xsl:with-param name="rada">
								<xsl:value-of select="concat($rada, name(), '[', $posnr, ']/')"/>
							</xsl:with-param>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
				<!-- peale elemendi teksti -->
				<xsl:if test="self::t:terg and following-sibling::node()[1][name() = 't:terg']">,</xsl:if>
				<xsl:if test="self::t:kom and not(following-sibling::node()[1][name() = 't:kom'])">
					<xsl:value-of select="'&lt;font color=&quot;blue&quot;&gt;--&amp;gt;&lt;/font&gt;'" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:if test="self::t:KOM">
					<xsl:value-of select="concat('&lt;', '/span', '&gt;')" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:if test="self::pref:A">
					<xsl:value-of select="concat('&lt;', '/p', '&gt;')" disable-output-escaping="yes"/>
				</xsl:if>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	<xsl:template match="text()">
		<xsl:param name="rada"/>
		<xsl:variable name="posnr">
			<xsl:number level="single" format="1"/>
		</xsl:variable>
		<xsl:value-of select="al:paneTyhikEtte(., local-name(..))"/>
		<xsl:element name="span">
			<xsl:if test="$printing = '0'">
				<xsl:attribute name="tabIndex">0</xsl:attribute>
				<xsl:attribute name="id">
					<xsl:value-of select="concat($rada, 'text()[', $posnr, ']')"/>
				</xsl:attribute>
				<xsl:attribute name="title">
					<xsl:value-of select="concat($rada, 'text()[', $posnr, ']')"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="class">
				<!--MS Word loeb sisse ainult esimese className-->
				<xsl:choose>
					<xsl:when test="1 = 2">
						<xsl:value-of select="concat('etvw_', translate(name(../..), ':', '_'), '_', translate(name(..), ':', '_'))"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="concat('etvw_', translate(name(..), ':', '_'))"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:value-of select="al:unNameXsl(local-name(..))"/>
				<xsl:if test="$edMode = '1'">
					<xsl:text> etvw noedit</xsl:text>
				</xsl:if>
				<xsl:if test="1 = 2">
					<xsl:text> lingike</xsl:text>
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="style">
				<xsl:if test="name(..) = 't:ter' and lang(&quot;en&quot;)">color:blue;</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="lang">
				<xsl:call-template name="get_lang"/>
			</xsl:attribute>
			<xsl:variable name="kursiiviMuutus">
				<xsl:choose>
					<xsl:when test="contains($itad, concat(';etvw_', local-name(..), ';'))">1</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:choose>
				<xsl:when test="1 = 2"/>
				<xsl:otherwise>
					<xsl:value-of select="al:RS(., $kursiiviMuutus, local-name(..), $printing)" disable-output-escaping="yes"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<xsl:template match="@*">
		<xsl:param name="rada"/>
		<xsl:element name="span">
			<xsl:if test="$printing = '0'">
				<xsl:attribute name="tabIndex">0</xsl:attribute>
				<xsl:attribute name="id">
					<xsl:value-of select="concat($rada, '@', name())"/>
				</xsl:attribute>
				<xsl:attribute name="title">
					<xsl:value-of select="concat($rada, '@', name())"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="class">
				<xsl:value-of select="concat('atvw_', translate(name(..), ':', '_'), '_', translate(name(), ':', '_'))"/>
				<xsl:value-of select="al:unNameXsl(local-name())"/>
				<xsl:if test="$edMode = '1'">
					<xsl:text> atvw noedit</xsl:text>
				</xsl:if>
				<xsl:if test="1 = 2">
					<xsl:text> lingike</xsl:text>
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="lang">
				<xsl:call-template name="get_lang"/>
			</xsl:attribute>
			<xsl:choose>
				<xsl:when test="1 = 2"/>
				<xsl:otherwise>
					<xsl:value-of select="al:RS(., '0', local-name(), $printing)" disable-output-escaping="yes"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>
	<xsl:template name="get_lang">
		<xsl:choose>
			<xsl:when test="lang('de')">de</xsl:when>
			<xsl:when test="lang('en')">en</xsl:when>
			<xsl:when test="lang('et')">et</xsl:when>
			<xsl:when test="lang('fi')">fi</xsl:when>
			<xsl:when test="lang('fr')">fr</xsl:when>
			<xsl:when test="lang('la')">la</xsl:when>
			<xsl:when test="lang('lt')">lt</xsl:when>
			<xsl:when test="lang('lv')">lv</xsl:when>
			<xsl:when test="lang('ru')">ru</xsl:when>
			<xsl:when test="lang('ud')">ud</xsl:when>
			<xsl:when test="lang('uk')">uk</xsl:when>
			<xsl:when test="lang('ex')">ex</xsl:when>
			<xsl:otherwise/>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
