﻿<?xml version="1.0"?>
<xsl:stylesheet version="1.0" t:mode="auto" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:pr_sd="http://www.eo.ee/dev/xml/names" xmlns:t="http://www.eki.ee/dict/fon">
	<xsl:output method="html" omit-xml-declaration="yes" indent="no" encoding="utf-8"/>
	<xsl:include href="include/incTemplates.xsl"/>
	<xsl:template match="text()" mode="el_in_mixed">
		<xsl:param name="rada"/>
		<xsl:param name="vanem_kirjeldav"/>
		<xsl:param name="vanem_muudetav"/>
		<xsl:param name="vanem_unname"/>
		<xsl:param name="alates"/>
		<xsl:variable name="allposnr">
			<xsl:number level="single" count="node()" format="1"></xsl:number>
		</xsl:variable>
		<xsl:if test="$allposnr &gt; 1">
			<xsl:text> </xsl:text>
		</xsl:if>
		<xsl:variable name="mposnr">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<xsl:element name="span">
			<xsl:attribute name="id">
				<xsl:value-of select="concat($rada, 'text()[', $mposnr, ']')"></xsl:value-of>
			</xsl:attribute>
			<xsl:attribute name="title">
				<xsl:value-of select="concat($vanem_kirjeldav, ': text()[', $mposnr, ']')"></xsl:value-of>
			</xsl:attribute>
			<xsl:attribute name="class">
				<xsl:value-of select="concat('et et_', $vanem_unname, ' ', $vanem_muudetav)"></xsl:value-of>
			</xsl:attribute>
			<xsl:choose>
				<xsl:when test="$alates = 'true' and count(../node()) = 1">
					<xsl:attribute name="style">width:100%;</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test=". = ''">
						<xsl:attribute name="style">width:16px;</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:attribute name="lang">
				<xsl:call-template name="get_lang"></xsl:call-template>
			</xsl:attribute>
			<xsl:attribute name="tabIndex">0</xsl:attribute>
			<xsl:value-of select="."></xsl:value-of>
		</xsl:element>
	</xsl:template>
	<xsl:template match="comment()" mode="el_in_mixed">
		<xsl:param name="rada"/>
		<xsl:param name="vanem_kirjeldav"/>
		<xsl:param name="vanem_muudetav"/>
		<xsl:param name="vanem_unname"/>
		<xsl:variable name="allposnr">
			<xsl:number level="single" count="node()" format="1"></xsl:number>
		</xsl:variable>
		<xsl:if test="$allposnr &gt; 1">
			<xsl:text> </xsl:text>
		</xsl:if>
		<xsl:variable name="mposnr">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<xsl:element name="span">
			<xsl:attribute name="id">
				<xsl:value-of select="concat($rada, 'comment()[', $mposnr, ']')"></xsl:value-of>
			</xsl:attribute>
			<xsl:attribute name="title">
				<xsl:value-of select="concat($vanem_kirjeldav, ': comment()[', $mposnr, ']')"></xsl:value-of>
			</xsl:attribute>
			<xsl:attribute name="class">
				<xsl:value-of select="concat('ct ct_', $vanem_unname, ' ', $vanem_muudetav)"></xsl:value-of>
			</xsl:attribute>
			<xsl:if test=". = ''">
				<xsl:attribute name="style">width:16px;</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="lang">
				<xsl:call-template name="get_lang"></xsl:call-template>
			</xsl:attribute>
			<xsl:attribute name="tabIndex">0</xsl:attribute>
			<xsl:value-of select="."></xsl:value-of>
		</xsl:element>
	</xsl:template>
	<xsl:template match="/">
		<body lang="et">
			<table id="cnt_tbl" border="1" width="100%" cellSpacing="0">
				<xsl:apply-templates select="*/*"></xsl:apply-templates>
			</table>
		</body>
	</xsl:template>
	<xsl:template match="t:A">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="posnr_A">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<xsl:if test="not(t:kp)">
			<tr>
				<td width="16px">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('creategrupp|t:kp|', $rada, 't:A[', $posnr_A, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</td>
				<td width="33%">
					<xsl:element name="span">
						<xsl:attribute name="title">t:kp</xsl:attribute>
						<xsl:attribute name="class">ec ec_t-kp_116_58_107_112 noedit</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>keele plokk</xsl:element>
				</td>
				<td></td>
				<td width="32px"></td>
			</tr>
		</xsl:if>
		<xsl:apply-templates select="t:kp">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:A[', $posnr_A, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:if test="not(t:KOM)">
			<tr>
				<td width="16px">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('creategrupp|t:KOM|', $rada, 't:A[', $posnr_A, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</td>
				<td width="33%">
					<xsl:element name="span">
						<xsl:attribute name="title">t:KOM</xsl:attribute>
						<xsl:attribute name="class">ec ec_t-KOM_116_58_75_79_77 noedit</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>kommentaaride plokk</xsl:element>
				</td>
				<td></td>
				<td width="32px"></td>
			</tr>
		</xsl:if>
		<xsl:apply-templates select="t:KOM">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:A[', $posnr_A, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
	<xsl:template match="t:kp">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="posnr_kp">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%">
				<xsl:element name="img">
					<xsl:attribute name="id">
						<xsl:value-of select="concat('addgrupp||', $rada, 't:kp[', $posnr_kp, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="src">graphics/justify.ico</xsl:attribute>
					<xsl:attribute name="alt">■</xsl:attribute>
					<xsl:attribute name="title">UUS "keele plokk"</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>
				</xsl:element>
			</td>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:kp[', $posnr_kp, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:kp[', $posnr_kp, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-kp_116_58_107_112 noedit</xsl:attribute>
					<xsl:attribute name="style">float:left;</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>keele plokk</xsl:element>
			</td>
			<td>
				<xsl:text> </xsl:text>
				<xsl:choose>
					<xsl:when test="@xml:lang">
						<xsl:element name="span">
							<xsl:attribute name="id">
								<xsl:value-of select="concat($rada, 't:kp[', $posnr_kp, ']/@xml:lang')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="title">
								<xsl:value-of select="concat('xml:lang: t:kp[', $posnr_kp, ']/@xml:lang')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="class">at at_xml-lang_120_109_108_58_108_97_110_103 edit</xsl:attribute>
							<xsl:if test="@xml:lang = ''">
								<xsl:attribute name="style">width:16px;</xsl:attribute>
							</xsl:if>
							<xsl:attribute name="lang">
								<xsl:call-template name="get_lang"></xsl:call-template>
							</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
							<xsl:value-of select="@xml:lang"></xsl:value-of>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name="img">
							<xsl:attribute name="border">1</xsl:attribute>
							<xsl:attribute name="id">
								<xsl:value-of select="concat('addAttr|xml:lang|', $rada, 't:kp[', $posnr_kp, ']')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="src">graphics/struprop_16-16.ico</xsl:attribute>
							<xsl:attribute name="alt">■</xsl:attribute>
							<xsl:attribute name="title">Lisa tunnus "xml:lang"</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td width="32px">
				<xsl:if test="not(t:d)">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('addlisad||', $rada, 't:kp[', $posnr_kp, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa puuduvad elemendid!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</xsl:if>
				<xsl:if test="*[. = '']">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('dellisad||', $rada, 't:kp[', $posnr_kp, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/delart 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Kustuta tühjad elemendid!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</xsl:if>
			</td>
		</tr>
		<xsl:if test="not(t:terg)">
			<tr>
				<td width="16px">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('creategrupp|t:terg|', $rada, 't:kp[', $posnr_kp, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</td>
				<td width="33%">
					<xsl:element name="span">
						<xsl:attribute name="title">t:terg</xsl:attribute>
						<xsl:attribute name="class">ec ec_t-terg_116_58_116_101_114_103 noedit</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>termini grupp</xsl:element>
				</td>
				<td></td>
				<td width="32px"></td>
			</tr>
		</xsl:if>
		<xsl:apply-templates select="t:terg">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:kp[', $posnr_kp, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:if test="not(t:d)">
			<tr>
				<td width="16px">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('creategrupp|t:d|', $rada, 't:kp[', $posnr_kp, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</td>
				<td width="33%">
					<xsl:element name="span">
						<xsl:attribute name="title">t:d</xsl:attribute>
						<xsl:attribute name="class">ec ec_t-d_116_58_100 noedit</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>seletus</xsl:element>
				</td>
				<td></td>
				<td width="32px"></td>
			</tr>
		</xsl:if>
		<xsl:apply-templates select="t:d">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:kp[', $posnr_kp, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:if test="not(t:plt)">
			<tr>
				<td width="16px">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('creategrupp|t:plt|', $rada, 't:kp[', $posnr_kp, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</td>
				<td width="33%">
					<xsl:element name="span">
						<xsl:attribute name="title">t:plt</xsl:attribute>
						<xsl:attribute name="class">ec ec_t-plt_116_58_112_108_116 noedit</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>pilt</xsl:element>
				</td>
				<td></td>
				<td width="32px"></td>
			</tr>
		</xsl:if>
		<xsl:apply-templates select="t:plt">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:kp[', $posnr_kp, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
	<xsl:template match="t:terg">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="posnr_terg">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%">
				<xsl:element name="img">
					<xsl:attribute name="id">
						<xsl:value-of select="concat('addgrupp||', $rada, 't:terg[', $posnr_terg, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="src">graphics/justify.ico</xsl:attribute>
					<xsl:attribute name="alt">■</xsl:attribute>
					<xsl:attribute name="title">UUS "termini grupp"</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>
				</xsl:element>
			</td>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:terg[', $posnr_terg, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:terg[', $posnr_terg, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-terg_116_58_116_101_114_103 noedit</xsl:attribute>
					<xsl:attribute name="style">float:left;</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>termini grupp</xsl:element>
			</td>
			<td/>
			<td width="32px">
				<xsl:if test="not(t:ter and t:mrk)">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('addlisad||', $rada, 't:terg[', $posnr_terg, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa puuduvad elemendid!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</xsl:if>
				<xsl:if test="*[. = '']">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('dellisad||', $rada, 't:terg[', $posnr_terg, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/delart 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Kustuta tühjad elemendid!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</xsl:if>
			</td>
		</tr>
		<xsl:apply-templates select="t:ter">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:terg[', $posnr_terg, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:if test="not(t:mrk)">
			<tr>
				<td width="16px">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('creategrupp|t:mrk|', $rada, 't:terg[', $posnr_terg, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</td>
				<td width="33%">
					<xsl:element name="span">
						<xsl:attribute name="title">t:mrk</xsl:attribute>
						<xsl:attribute name="class">ec ec_t-mrk_116_58_109_114_107 noedit</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>märkus</xsl:element>
				</td>
				<td></td>
				<td width="32px"></td>
			</tr>
		</xsl:if>
		<xsl:apply-templates select="t:mrk">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:terg[', $posnr_terg, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
	<xsl:template match="t:plt">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="posnr_plt">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%">
				<xsl:element name="img">
					<xsl:attribute name="id">
						<xsl:value-of select="concat('addgrupp||', $rada, 't:plt[', $posnr_plt, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="src">graphics/justify.ico</xsl:attribute>
					<xsl:attribute name="alt">■</xsl:attribute>
					<xsl:attribute name="title">UUS "pilt"</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>
				</xsl:element>
			</td>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:plt[', $posnr_plt, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:plt[', $posnr_plt, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-plt_116_58_112_108_116 noedit</xsl:attribute>
					<xsl:attribute name="style">float:left;</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>pilt</xsl:element>
			</td>
			<td/>
			<td width="32px">
				<xsl:if test="not(t:pf and t:pn)">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('addlisad||', $rada, 't:plt[', $posnr_plt, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa puuduvad elemendid!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</xsl:if>
				<xsl:if test="*[. = '']">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('dellisad||', $rada, 't:plt[', $posnr_plt, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/delart 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Kustuta tühjad elemendid!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</xsl:if>
			</td>
		</tr>
		<xsl:apply-templates select="t:pf">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:plt[', $posnr_plt, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:apply-templates select="t:pn">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:plt[', $posnr_plt, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
	<xsl:template match="t:KOM">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="posnr_KOM">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td colspan="2" width="35%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:KOM[', $posnr_KOM, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:KOM[', $posnr_KOM, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-KOM_116_58_75_79_77 noedit</xsl:attribute>
					<xsl:attribute name="style">float:left;</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>kommentaaride plokk</xsl:element>
			</td>
			<td/>
			<td width="32px"></td>
		</tr>
		<xsl:if test="not(t:komg)">
			<tr>
				<td width="16px">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('creategrupp|t:komg|', $rada, 't:KOM[', $posnr_KOM, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</td>
				<td width="33%">
					<xsl:element name="span">
						<xsl:attribute name="title">t:komg</xsl:attribute>
						<xsl:attribute name="class">ec ec_t-komg_116_58_107_111_109_103 noedit</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>kommentaari grupp</xsl:element>
				</td>
				<td></td>
				<td width="32px"></td>
			</tr>
		</xsl:if>
		<xsl:apply-templates select="t:komg">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:KOM[', $posnr_KOM, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
	<xsl:template match="t:komg">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="posnr_komg">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%">
				<xsl:element name="img">
					<xsl:attribute name="id">
						<xsl:value-of select="concat('addgrupp||', $rada, 't:komg[', $posnr_komg, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="src">graphics/justify.ico</xsl:attribute>
					<xsl:attribute name="alt">■</xsl:attribute>
					<xsl:attribute name="title">UUS "kommentaari grupp"</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>
				</xsl:element>
			</td>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:komg[', $posnr_komg, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:komg[', $posnr_komg, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-komg_116_58_107_111_109_103 noedit</xsl:attribute>
					<xsl:attribute name="style">float:left;</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>kommentaari grupp</xsl:element>
			</td>
			<td/>
			<td width="32px">
				<xsl:if test="not(t:kom and t:kaut and t:kaeg)">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('addlisad||', $rada, 't:komg[', $posnr_komg, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/downarrow 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Lisa puuduvad elemendid!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</xsl:if>
				<xsl:if test="*[. = '']">
					<xsl:element name="img">
						<xsl:attribute name="id">
							<xsl:value-of select="concat('dellisad||', $rada, 't:komg[', $posnr_komg, ']')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="src">graphics/delart 16-16.ico</xsl:attribute>
						<xsl:attribute name="alt">■</xsl:attribute>
						<xsl:attribute name="title">Kustuta tühjad elemendid!</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:element>
				</xsl:if>
			</td>
		</tr>
		<xsl:apply-templates select="t:kom">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:komg[', $posnr_komg, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:apply-templates select="t:kaut">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:komg[', $posnr_komg, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:apply-templates select="t:kaeg">
			<xsl:with-param name="rada">
				<xsl:value-of select="concat($rada, 't:komg[', $posnr_komg, ']/')"></xsl:value-of>
			</xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>
	<xsl:template match="t:ter">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="psCount">
			<xsl:value-of select="count(preceding-sibling::*)"></xsl:value-of>
		</xsl:variable>
		<xsl:apply-templates select="preceding-sibling::comment()[count(preceding-sibling::*) = number($psCount)]">
			<xsl:with-param name="rada">
				<xsl:value-of select="$rada"></xsl:value-of>
			</xsl:with-param>
			<xsl:with-param name="vanem_kirjeldav">
				<xsl:value-of select="../@pr_sd:desc"/>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:variable name="posnr_ter">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%"/>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:ter[', $posnr_ter, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:ter[', $posnr_ter, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-ter_116_58_116_101_114 noedit</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>termin</xsl:element>
				<xsl:text> </xsl:text>
				<xsl:choose>
					<xsl:when test="@t:tT">
						<xsl:element name="span">
							<xsl:attribute name="id">
								<xsl:value-of select="concat($rada, 't:ter[', $posnr_ter, ']/@t:tT')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="title">
								<xsl:value-of select="concat('termini tüüp: t:ter[', $posnr_ter, ']/@t:tT')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="class">at at_t-tT_116_58_116_84 edit</xsl:attribute>
							<xsl:if test="@t:tT = ''">
								<xsl:attribute name="style">width:16px;</xsl:attribute>
							</xsl:if>
							<xsl:attribute name="lang">
								<xsl:call-template name="get_lang"></xsl:call-template>
							</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
							<xsl:value-of select="@t:tT"></xsl:value-of>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name="img">
							<xsl:attribute name="border">1</xsl:attribute>
							<xsl:attribute name="id">
								<xsl:value-of select="concat('addAttr|t:tT|', $rada, 't:ter[', $posnr_ter, ']')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="src">graphics/struprop_16-16.ico</xsl:attribute>
							<xsl:attribute name="alt">■</xsl:attribute>
							<xsl:attribute name="title">Lisa tunnus "termini tüüp"</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td>
				<xsl:if test="text()">
					<xsl:element name="span">
						<xsl:attribute name="id">
							<xsl:value-of select="concat($rada, 't:ter[', $posnr_ter, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="title">
							<xsl:value-of select="concat('t:ter[', $posnr_ter, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="class">et et_t-ter_116_58_116_101_114 edit etws</xsl:attribute>
						<xsl:attribute name="lang">
							<xsl:call-template name="get_lang"></xsl:call-template>
						</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
						<xsl:value-of select="."></xsl:value-of>
					</xsl:element>
				</xsl:if>
			</td>
			<td width="32px"></td>
		</tr>
	</xsl:template>
	<xsl:template match="t:mrk">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="psCount">
			<xsl:value-of select="count(preceding-sibling::*)"></xsl:value-of>
		</xsl:variable>
		<xsl:apply-templates select="preceding-sibling::comment()[count(preceding-sibling::*) = number($psCount)]">
			<xsl:with-param name="rada">
				<xsl:value-of select="$rada"></xsl:value-of>
			</xsl:with-param>
			<xsl:with-param name="vanem_kirjeldav">
				<xsl:value-of select="../@pr_sd:desc"/>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:variable name="posnr_mrk">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%">
				<xsl:element name="img">
					<xsl:attribute name="id">
						<xsl:value-of select="concat('addgrupp||', $rada, 't:mrk[', $posnr_mrk, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="src">graphics/justify.ico</xsl:attribute>
					<xsl:attribute name="alt">■</xsl:attribute>
					<xsl:attribute name="title">UUS "märkus"</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>
				</xsl:element>
			</td>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:mrk[', $posnr_mrk, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:mrk[', $posnr_mrk, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-mrk_116_58_109_114_107 noedit</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>märkus</xsl:element>
				<xsl:text> </xsl:text>
				<xsl:choose>
					<xsl:when test="@t:maut">
						<xsl:element name="span">
							<xsl:attribute name="id">
								<xsl:value-of select="concat($rada, 't:mrk[', $posnr_mrk, ']/@t:maut')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="title">
								<xsl:value-of select="concat('märkuse autor: t:mrk[', $posnr_mrk, ']/@t:maut')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="class">at at_t-maut_116_58_109_97_117_116 noedit</xsl:attribute>
							<xsl:if test="@t:maut = ''">
								<xsl:attribute name="style">width:16px;</xsl:attribute>
							</xsl:if>
							<xsl:attribute name="lang">
								<xsl:call-template name="get_lang"></xsl:call-template>
							</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
							<xsl:value-of select="@t:maut"></xsl:value-of>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name="img">
							<xsl:attribute name="border">1</xsl:attribute>
							<xsl:attribute name="id">
								<xsl:value-of select="concat('addAttr|t:maut|', $rada, 't:mrk[', $posnr_mrk, ']')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="src">graphics/struprop_16-16.ico</xsl:attribute>
							<xsl:attribute name="alt">■</xsl:attribute>
							<xsl:attribute name="title">Lisa tunnus "märkuse autor"</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text> </xsl:text>
				<xsl:choose>
					<xsl:when test="@t:maeg">
						<xsl:element name="span">
							<xsl:attribute name="id">
								<xsl:value-of select="concat($rada, 't:mrk[', $posnr_mrk, ']/@t:maeg')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="title">
								<xsl:value-of select="concat('märkuse aeg: t:mrk[', $posnr_mrk, ']/@t:maeg')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="class">at at_t-maeg_116_58_109_97_101_103 noedit</xsl:attribute>
							<xsl:if test="@t:maeg = ''">
								<xsl:attribute name="style">width:16px;</xsl:attribute>
							</xsl:if>
							<xsl:attribute name="lang">
								<xsl:call-template name="get_lang"></xsl:call-template>
							</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
							<xsl:value-of select="@t:maeg"></xsl:value-of>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name="img">
							<xsl:attribute name="border">1</xsl:attribute>
							<xsl:attribute name="id">
								<xsl:value-of select="concat('addAttr|t:maeg|', $rada, 't:mrk[', $posnr_mrk, ']')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="src">graphics/struprop_16-16.ico</xsl:attribute>
							<xsl:attribute name="alt">■</xsl:attribute>
							<xsl:attribute name="title">Lisa tunnus "märkuse aeg"</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td>
				<xsl:if test="text()">
					<xsl:element name="span">
						<xsl:attribute name="id">
							<xsl:value-of select="concat($rada, 't:mrk[', $posnr_mrk, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="title">
							<xsl:value-of select="concat('t:mrk[', $posnr_mrk, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="class">et et_t-mrk_116_58_109_114_107 edit etws</xsl:attribute>
						<xsl:attribute name="lang">
							<xsl:call-template name="get_lang"></xsl:call-template>
						</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
						<xsl:value-of select="."></xsl:value-of>
					</xsl:element>
				</xsl:if>
			</td>
			<td width="32px"></td>
		</tr>
	</xsl:template>
	<xsl:template match="t:d">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="psCount">
			<xsl:value-of select="count(preceding-sibling::*)"></xsl:value-of>
		</xsl:variable>
		<xsl:apply-templates select="preceding-sibling::comment()[count(preceding-sibling::*) = number($psCount)]">
			<xsl:with-param name="rada">
				<xsl:value-of select="$rada"></xsl:value-of>
			</xsl:with-param>
			<xsl:with-param name="vanem_kirjeldav">
				<xsl:value-of select="../@pr_sd:desc"/>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:variable name="posnr_d">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%"/>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:d[', $posnr_d, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:d[', $posnr_d, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-d_116_58_100 noedit</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>seletus</xsl:element>
			</td>
			<td>
				<xsl:if test="text()">
					<xsl:element name="span">
						<xsl:attribute name="id">
							<xsl:value-of select="concat($rada, 't:d[', $posnr_d, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="title">
							<xsl:value-of select="concat('t:d[', $posnr_d, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="class">et et_t-d_116_58_100 edit etws</xsl:attribute>
						<xsl:attribute name="lang">
							<xsl:call-template name="get_lang"></xsl:call-template>
						</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
						<xsl:value-of select="."></xsl:value-of>
					</xsl:element>
				</xsl:if>
			</td>
			<td width="32px"></td>
		</tr>
	</xsl:template>
	<xsl:template match="t:pf">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="psCount">
			<xsl:value-of select="count(preceding-sibling::*)"></xsl:value-of>
		</xsl:variable>
		<xsl:apply-templates select="preceding-sibling::comment()[count(preceding-sibling::*) = number($psCount)]">
			<xsl:with-param name="rada">
				<xsl:value-of select="$rada"></xsl:value-of>
			</xsl:with-param>
			<xsl:with-param name="vanem_kirjeldav">
				<xsl:value-of select="../@pr_sd:desc"/>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:variable name="posnr_pf">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%"/>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:pf[', $posnr_pf, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:pf[', $posnr_pf, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-pf_116_58_112_102 noedit</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>pildifail</xsl:element>
				<xsl:text> </xsl:text>
				<xsl:choose>
					<xsl:when test="@t:mW">
						<xsl:element name="span">
							<xsl:attribute name="id">
								<xsl:value-of select="concat($rada, 't:pf[', $posnr_pf, ']/@t:mW')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="title">
								<xsl:value-of select="concat('pildi laius: t:pf[', $posnr_pf, ']/@t:mW')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="class">at at_t-mW_116_58_109_87 edit</xsl:attribute>
							<xsl:if test="@t:mW = ''">
								<xsl:attribute name="style">width:16px;</xsl:attribute>
							</xsl:if>
							<xsl:attribute name="lang">
								<xsl:call-template name="get_lang"></xsl:call-template>
							</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
							<xsl:value-of select="@t:mW"></xsl:value-of>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name="img">
							<xsl:attribute name="border">1</xsl:attribute>
							<xsl:attribute name="id">
								<xsl:value-of select="concat('addAttr|t:mW|', $rada, 't:pf[', $posnr_pf, ']')"></xsl:value-of>
							</xsl:attribute>
							<xsl:attribute name="src">graphics/struprop_16-16.ico</xsl:attribute>
							<xsl:attribute name="alt">■</xsl:attribute>
							<xsl:attribute name="title">Lisa tunnus "pildi laius"</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td>
				<xsl:if test="text()">
					<xsl:element name="span">
						<xsl:attribute name="id">
							<xsl:value-of select="concat($rada, 't:pf[', $posnr_pf, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="title">
							<xsl:value-of select="concat('t:pf[', $posnr_pf, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="class">et et_t-pf_116_58_112_102 edit etws</xsl:attribute>
						<xsl:attribute name="lang">
							<xsl:call-template name="get_lang"></xsl:call-template>
						</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
						<xsl:value-of select="."></xsl:value-of>
					</xsl:element>
				</xsl:if>
			</td>
			<td width="32px"></td>
		</tr>
	</xsl:template>
	<xsl:template match="t:pn">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="psCount">
			<xsl:value-of select="count(preceding-sibling::*)"></xsl:value-of>
		</xsl:variable>
		<xsl:apply-templates select="preceding-sibling::comment()[count(preceding-sibling::*) = number($psCount)]">
			<xsl:with-param name="rada">
				<xsl:value-of select="$rada"></xsl:value-of>
			</xsl:with-param>
			<xsl:with-param name="vanem_kirjeldav">
				<xsl:value-of select="../@pr_sd:desc"/>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:variable name="posnr_pn">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%"/>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:pn[', $posnr_pn, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:pn[', $posnr_pn, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-pn_116_58_112_110 noedit</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>pildi nimetus</xsl:element>
			</td>
			<td>
				<xsl:if test="text()">
					<xsl:element name="span">
						<xsl:attribute name="id">
							<xsl:value-of select="concat($rada, 't:pn[', $posnr_pn, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="title">
							<xsl:value-of select="concat('t:pn[', $posnr_pn, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="class">et et_t-pn_116_58_112_110 edit etws</xsl:attribute>
						<xsl:attribute name="lang">
							<xsl:call-template name="get_lang"></xsl:call-template>
						</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
						<xsl:value-of select="."></xsl:value-of>
					</xsl:element>
				</xsl:if>
			</td>
			<td width="32px"></td>
		</tr>
	</xsl:template>
	<xsl:template match="t:kom">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="psCount">
			<xsl:value-of select="count(preceding-sibling::*)"></xsl:value-of>
		</xsl:variable>
		<xsl:apply-templates select="preceding-sibling::comment()[count(preceding-sibling::*) = number($psCount)]">
			<xsl:with-param name="rada">
				<xsl:value-of select="$rada"></xsl:value-of>
			</xsl:with-param>
			<xsl:with-param name="vanem_kirjeldav">
				<xsl:value-of select="../@pr_sd:desc"/>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:variable name="posnr_kom">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%"/>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:kom[', $posnr_kom, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:kom[', $posnr_kom, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-kom_116_58_107_111_109 noedit</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>kommentaar</xsl:element>
			</td>
			<td>
				<xsl:if test="text()">
					<xsl:element name="span">
						<xsl:attribute name="id">
							<xsl:value-of select="concat($rada, 't:kom[', $posnr_kom, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="title">
							<xsl:value-of select="concat('t:kom[', $posnr_kom, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="class">et et_t-kom_116_58_107_111_109 edit etws</xsl:attribute>
						<xsl:attribute name="lang">
							<xsl:call-template name="get_lang"></xsl:call-template>
						</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
						<xsl:value-of select="."></xsl:value-of>
					</xsl:element>
				</xsl:if>
			</td>
			<td width="32px"></td>
		</tr>
	</xsl:template>
	<xsl:template match="t:kaut">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="psCount">
			<xsl:value-of select="count(preceding-sibling::*)"></xsl:value-of>
		</xsl:variable>
		<xsl:apply-templates select="preceding-sibling::comment()[count(preceding-sibling::*) = number($psCount)]">
			<xsl:with-param name="rada">
				<xsl:value-of select="$rada"></xsl:value-of>
			</xsl:with-param>
			<xsl:with-param name="vanem_kirjeldav">
				<xsl:value-of select="../@pr_sd:desc"/>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:variable name="posnr_kaut">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%"/>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:kaut[', $posnr_kaut, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:kaut[', $posnr_kaut, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-kaut_116_58_107_97_117_116 noedit</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>kommentaari autor</xsl:element>
			</td>
			<td>
				<xsl:if test="text()">
					<xsl:element name="span">
						<xsl:attribute name="id">
							<xsl:value-of select="concat($rada, 't:kaut[', $posnr_kaut, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="title">
							<xsl:value-of select="concat('t:kaut[', $posnr_kaut, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="class">et et_t-kaut_116_58_107_97_117_116 noedit etws</xsl:attribute>
						<xsl:attribute name="lang">
							<xsl:call-template name="get_lang"></xsl:call-template>
						</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
						<xsl:value-of select="."></xsl:value-of>
					</xsl:element>
				</xsl:if>
			</td>
			<td width="32px"></td>
		</tr>
	</xsl:template>
	<xsl:template match="t:kaeg">
		<xsl:param name="rada"></xsl:param>
		<xsl:variable name="psCount">
			<xsl:value-of select="count(preceding-sibling::*)"></xsl:value-of>
		</xsl:variable>
		<xsl:apply-templates select="preceding-sibling::comment()[count(preceding-sibling::*) = number($psCount)]">
			<xsl:with-param name="rada">
				<xsl:value-of select="$rada"></xsl:value-of>
			</xsl:with-param>
			<xsl:with-param name="vanem_kirjeldav">
				<xsl:value-of select="../@pr_sd:desc"/>
			</xsl:with-param>
		</xsl:apply-templates>
		<xsl:variable name="posnr_kaeg">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td width="2%"/>
			<td width="33%">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 't:kaeg[', $posnr_kaeg, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat('t:kaeg[', $posnr_kaeg, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">en en_t-kaeg_116_58_107_97_101_103 noedit</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>kommenteerimisaeg</xsl:element>
			</td>
			<td>
				<xsl:if test="text()">
					<xsl:element name="span">
						<xsl:attribute name="id">
							<xsl:value-of select="concat($rada, 't:kaeg[', $posnr_kaeg, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="title">
							<xsl:value-of select="concat('t:kaeg[', $posnr_kaeg, ']/text()[1]')"></xsl:value-of>
						</xsl:attribute>
						<xsl:attribute name="class">et et_t-kaeg_116_58_107_97_101_103 noedit etws</xsl:attribute>
						<xsl:attribute name="lang">
							<xsl:call-template name="get_lang"></xsl:call-template>
						</xsl:attribute>
						<xsl:attribute name="tabIndex">0</xsl:attribute>
						<xsl:value-of select="."></xsl:value-of>
					</xsl:element>
				</xsl:if>
			</td>
			<td width="32px"></td>
		</tr>
	</xsl:template>
	<xsl:template match="comment()">
		<xsl:param name="rada"></xsl:param>
		<xsl:param name="vanem_kirjeldav"/>
		<xsl:param name="vanem_muudetav"/>
		<xsl:param name="vanem_unname"/>
		<xsl:variable name="posnr_comment">
			<xsl:number level="single" format="1"></xsl:number>
		</xsl:variable>
		<tr>
			<td colspan="4">
				<xsl:element name="span">
					<xsl:attribute name="id">
						<xsl:value-of select="concat($rada, 'comment()[', $posnr_comment, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="concat($vanem_kirjeldav, ': ', name(..), '/comment()[', $posnr_comment, ']')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="class">
						<xsl:value-of select="concat('ct ct_', $vanem_unname, ' edit etws')"></xsl:value-of>
					</xsl:attribute>
					<xsl:attribute name="lang">
						<xsl:call-template name="get_lang"></xsl:call-template>
					</xsl:attribute>
					<xsl:attribute name="tabIndex">0</xsl:attribute>
					<xsl:value-of select="."></xsl:value-of>
				</xsl:element>
			</td>
		</tr>
	</xsl:template>
</xsl:stylesheet>
